local prefix = "|cff1784d1L-C|cffffa500CD|r: |r"
local flag = false
local delay = 0
local addonName = ' |cffCE5C00Lemmos|r |cff729FCFCraft|r|cff73D216Cooldown|r'
local addonVersion = "7.0"
local lccd_options = {
    main = CreateFrame("FRAME"),
    }
local lccd_MainFrame = CreateFrame("FRAME")
local alphassdisp = 1
local skillName = nil
local readyAt = nil
local seconds = nil
local ownprof = nil
local cdtriggered = nil
local mmessage = nil
local mmessagett = ""
local lccd_gdcfilter = ""
local lccd_gdcfilterrealm = ""
local lccd_gdcfilterprof = ""
local lccd_gdcfilterskill = ""
local lccd_hasLeatherworking = false
local lccd_playerwasincombat = false
local lccd_cooldownstriggered = {}
local dayOfWeek = {WEEKDAY_SUNDAY, WEEKDAY_MONDAY, WEEKDAY_TUESDAY, WEEKDAY_WEDNESDAY, WEEKDAY_THURSDAY, WEEKDAY_FRIDAY, WEEKDAY_SATURDAY}

local lccd_wowv = 0

local _, _, _, lccd_tocver = GetBuildInfo()
if lccd_tocver < 20000 then
    lccd_wowv = 1
elseif lccd_tocver>20000 and lccd_tocver <30000 then
    lccd_wowv = 2
elseif lccd_tocver>30000 and lccd_tocver <40000 then
    lccd_wowv = 3
elseif lccd_tocver>90000 then
    lccd_wowv = 9
end


local lccd_SMELTING = 2656
local lccd_MINING = 2575
--
-- a table of tradeskills by id
--
local lccd_TradeSkillList = {
    2259,		-- alchemy
    2018,		-- blacksmithing
    4036,		-- engineering
    2108,		-- leatherworking
    lccd_SMELTING,	-- smelting
    lccd_MINING,		-- mining
    3908,		-- tailoring
    2550,		-- cooking
    3273,		-- first aid
    2842,		-- poisons
--	45357,		-- inscription (not in Classic)
--  25229,		-- jewelcrafting (not in Classic)
--	53428,		-- runeforging (not in Classic)
}

local lccd_CraftList = {
--	5149,		-- beast training
--  7411,		-- enchanting
}


if (lccd_wowv == 2) then
    lccd_TradeSkillList = {
        2259,		-- alchemy
        2018,		-- blacksmithing
        4036,		-- engineering
        2108,		-- leatherworking
        lccd_SMELTING,	-- smelting
        lccd_MINING,		-- mining
        3908,		-- tailoring
        2550,		-- cooking
        3273,		-- first aid
        2842,		-- poisons
    --	45357,		-- inscription (not in Classic)
        25229,		-- jewelcrafting (not in Classic)
    --	53428,		-- runeforging (not in Classic)
    }

    lccd_CraftList = {
    --	5149,		-- beast training
        7411,		-- enchanting
    }
end

if (lccd_wowv == 3) then
    lccd_TradeSkillList = {
        2259,		-- alchemy
        2018,		-- blacksmithing
        4036,		-- engineering
        2108,		-- leatherworking
        lccd_SMELTING,	-- smelting
        lccd_MINING,		-- mining
        3908,		-- tailoring
        2550,		-- cooking
        3273,		-- first aid
        2842,		-- poisons
    	45357,		-- inscription (not in Classic)
        25229,		-- jewelcrafting (not in Classic)
        53428,
        7411,		-- runeforging (not in Classic)
    }

    lccd_CraftList = {
    --	5149,		-- beast training
    --    7411,		-- enchanting
    }
end

local lccd_alchemylist = {
    7068,
    12360,
    7078,
    7076,
    7080,
    7082,
    12808,
    12803,
    3577,
    6037,
    }
    
if (lccd_wowv == 2) then
    lccd_alchemylist = {
        21885,
        22456,
        21884,
        22457,
        22452,
        21886,
        22451,
        23571,
        25867,
        25868,
        7078,
        7076,
        7080,
        7082,
        12808,
        12803,
        3577,
        6037,
        }
end

if (lccd_wowv == 3) then
    lccd_alchemylist = {
        41163,
        36860,
        35623,
        35627,
        35625,
        35624,
        35622,
        36919,
        36934,
        36925,
        36928,
        36922,
        36931,
        21885,
        22456,
        21884,
        22457,
        22452,
        21886,
        22451,
        7078,
        7076,
        7080,
        7082,
        12808,
        12803,
        3577,
        6037,
        }
end

local lccd_inscriptionlist = {}

if (lccd_wowv == 2) then
    lccd_inscriptionlist = {
        61288,
        61177,
        }
end

if (lccd_wowv == 3) then
    lccd_inscriptionlist = {
        61288,
        61177,
        }
end

local lccd_enchantinglist = {}

if (lccd_wowv == 2) then
    lccd_enchantinglist = {
        28028,
        28028,
        }
end

if (lccd_wowv == 3) then
    lccd_enchantinglist = {
        28028,
        28028,
        }
end

local lccd_tailoringlist = {
    14342,
    }

if (lccd_wowv == 2) then
    lccd_tailoringlist = {
        24272,
        21845,
        24271,
        }
end

if (lccd_wowv == 3) then
    lccd_tailoringlist = {
        41595,
        41594,
        41593,
        }
end

local lccd_jewelcraftinglist = {}

if (lccd_wowv == 2) then
    lccd_jewelcraftinglist = {
        35945,
        }
end

if (lccd_wowv == 3) then
    lccd_jewelcraftinglist = {
        35945,
        44943,
        }
end

local lccd_sslist = {
    15846,
    }

if (lccd_wowv == 2) then
    lccd_sslist = {
    15846,
    }
end

if (lccd_wowv == 3) then
    lccd_sslist = {}
end

function lccd_arraycontainsvalue(inputarray, searchvalue)
    for _, value in pairs(inputarray) do
        if value == searchvalue then
            return true
        end
    end
    return false
end


local ssdisp = CreateFrame("Frame", "L-CCD-Salt_shaker", UIParent)
ssdisp:SetWidth(16)
ssdisp:SetHeight(16)
ssdisp:EnableMouse(true)
ssdisp:SetScript("OnMouseDown", function(self, button)
        if ssdisp:IsMovable() then
            if button == "LeftButton" and not self.isMoving then
                self:StartMoving();
                self.isMoving = true;
            end
        end
    end)
ssdisp:SetScript("OnMouseUp", function(self, button)
    if button == "MiddleButton" then
        lccd_printCached();
    end
    if button == "LeftButton" and self.isMoving and ssdisp:IsMovable() then
        self:StopMovingOrSizing();
        self.isMoving = false;
        local _, _, ssrelpoint, ssposx, ssposy = ssdisp:GetPoint();
        lccd_usercache['IconPosrel'] = ssrelpoint;
        lccd_usercache['IconPosx'] = ssposx;
        lccd_usercache['IconPosy'] = ssposy;
    end
    if button == "RightButton" then
	InterfaceOptionsFrame_OpenToCategory(addonName)
	InterfaceOptionsFrame_OpenToCategory(addonName);
    end
end)
ssdisp:SetScript("OnHide", function(self)
    if ( self.isMoving ) then
        self:StopMovingOrSizing();
        self.isMoving = false;
    end
end)
ssdisp:SetScript("OnEnter", function(self, motion)
    lccd_printToltip(ssdisp, "ANCHOR_BOTTOMRIGHT")
    end)
ssdisp:SetScript("OnLeave", function(self, motion)
    GameTooltip:Hide()
    end)

ssdisp.texture = ssdisp:CreateTexture();
ssdisp.texture:SetAllPoints();
ssdisp.texture:SetTexture("Interface\\ICONS\\INV_Egg_05.blp");
ssdisp.texture:SetAlpha(alphassdisp);

local ssdisp1 = CreateFrame("Frame", "L-CCD-Salt_shaker1", ssdisp)
ssdisp1:SetWidth(9)
ssdisp1:SetHeight(9)
ssdisp1.texture = ssdisp1:CreateTexture();
ssdisp1.texture:SetAllPoints();
ssdisp1.texture:SetTexture(nil);

local ssdisp2 = CreateFrame("Frame", "L-CCD-Mooncloth", ssdisp)
ssdisp2:SetWidth(9)
ssdisp2:SetHeight(9)
ssdisp2.texture = ssdisp2:CreateTexture();
ssdisp2.texture:SetAllPoints();
ssdisp2.texture:SetTexture(nil);

local ssdisp3 = CreateFrame("Frame", "L-CCD-Arcanite", ssdisp)
ssdisp3:SetWidth(9)
ssdisp3:SetHeight(9)
ssdisp3.texture = ssdisp3:CreateTexture();
ssdisp3.texture:SetAllPoints();
ssdisp3.texture:SetTexture(nil);

local ssdisp4 = CreateFrame("Frame", "L-CCD-Jewelcrafting", ssdisp)
ssdisp4:SetPoint("TOPRIGHT", ssdisp, "TOPRIGHT", 3, 3)
ssdisp4:SetWidth(9)
ssdisp4:SetHeight(9)
ssdisp4.texture = ssdisp4:CreateTexture();
ssdisp4.texture:SetAllPoints();
ssdisp4.texture:SetTexture(nil);

local ssdisp5 = CreateFrame("Frame", "L-CCD-Enchanting", ssdisp)
ssdisp5:SetPoint("CENTER", ssdisp, "CENTER", 0, 0)
ssdisp5:SetWidth(9)
ssdisp5:SetHeight(9)
ssdisp5.texture = ssdisp5:CreateTexture();
ssdisp5.texture:SetAllPoints();
ssdisp5.texture:SetTexture(nil);

local ssdisp6 = CreateFrame("Frame", "L-CCD-Inscription", ssdisp)
ssdisp6:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
ssdisp6:SetWidth(9)
ssdisp6:SetHeight(9)
ssdisp6.texture = ssdisp6:CreateTexture();
ssdisp6.texture:SetAllPoints();
ssdisp6.texture:SetTexture(nil);

local ssdisp3ap = CreateFrame("Frame", "L-CCD-Personalcd", ssdisp)
ssdisp3ap:SetWidth(16)
ssdisp3ap:SetHeight(16)
ssdisp3ap.texture = ssdisp3ap:CreateTexture();
ssdisp3ap.texture:SetAllPoints();
ssdisp3ap.texture:SetTexture(nil);

if (lccd_wowv == 2 or lccd_wowv == 3) then
    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
    ssdisp2:SetPoint("BOTTOMRIGHT", ssdisp, "BOTTOMRIGHT", 3, -3)
    ssdisp3:SetPoint("BOTTOMLEFT", ssdisp, "BOTTOMLEFT", -3, -3)
    ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, -3)
else
    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -2, 2)
    ssdisp2:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", 10, 2)
    ssdisp3:SetPoint("CENTER", ssdisp, "CENTER", 0, -5)
    ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, 0)
end



function lccd_moveicon(on)
    if on
        then
        ssdisp:SetMovable(true)
        ssdisp:RegisterForDrag("LeftButton")
    else
        ssdisp:SetMovable(false)
        ssdisp:RegisterForDrag(nil)
    end
end

local lccd_widgetButton = CreateFrame("Button", nil, UIParent)
lccd_widgetButton = lccd_widgetButton
lccd_widgetButton:SetMovable(true)
lccd_widgetButton:SetSize(6, 20)
--lccd_widgetButton:SetPoint("LEFT", 0, 0)
lccd_widgetButton:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfnopenl.tga")
lccd_widgetButton:SetPushedTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")
lccd_widgetButton:SetHighlightTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")

local lccd_widget = CreateFrame("FRAME", "L-CCD-Widget", lccd_widgetButton, BackdropTemplateMixin and "BackdropTemplate")
lccd_widget:SetPoint("TOPLEFT", lccd_widgetButton, "TOPRIGHT", 0, 0)
lccd_widget:SetWidth(100)
lccd_widget:SetHeight(20)
--lccd_widget:EnableMouse(false)
lccd_widget:SetBackdrop({
    bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bggrey",
    tile = true,
    edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border2",
    edgeSize = 8,
    insets = {
        left = 1,
        right = 1,
        top = 1,
        bottom = 1,
    },
})
lccd_widget:SetScript("OnEnter", function(self, motion)
    lccd_printToltip(lccd_widget, "ANCHOR_RIGHT")
    end)
lccd_widget:SetScript("OnLeave", function(self, motion)
    GameTooltip:Hide()
    end)

lccd_widget:SetScript("OnMouseDown", function(self, button)
        if lccd_widgetButton:IsMovable() then
            if button == "LeftButton" and not lccd_widgetButton.isMoving then
                lccd_widgetButton:StartMoving();
                lccd_widgetButton.isMoving = true;
            end
        end
    end)
lccd_widget:SetScript("OnMouseUp", function(self, button)
    if button == "LeftButton" and lccd_widgetButton.isMoving and lccd_widgetButton:IsMovable() then
        lccd_widgetButton:StopMovingOrSizing();
        lccd_widgetButton.isMoving = false;
        local _, _, relpoint, posx, posy = lccd_widgetButton:GetPoint();
        lccd_usercache['WidgetPosrel'] = relpoint;
        lccd_usercache['WidgetPosx'] = posx;
        lccd_usercache['WidgetPosy'] = posy;
    end
end)
lccd_widget:SetScript("OnHide", function(self)
    if ( lccd_widgetButton.isMoving ) then
        lccd_widgetButton:StopMovingOrSizing();
        lccd_widgetButton.isMoving = false;
    end
end)

function lccd_movewidget(on)
    if on
        then
        lccd_widget:EnableMouse(true)
        lccd_widget:RegisterForDrag("LeftButton")
    else
        lccd_widget:EnableMouse(false)
        lccd_widget:RegisterForDrag(nil)
    end
end

local lccd_widgettxt = lccd_widget:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
lccd_widgettxt:SetPoint("TOP", 0, -5)
lccd_widgettxt:SetText("")

--lccd_widgetButton:SetScript("OnEnter", function(self, motion)
--    lccd_printToltip(lccd_widgetButton, "ANCHOR_BOTTOMRIGHT")
--    end)
--lccd_widgetButton:SetScript("OnLeave", function(self, motion)
--    GameTooltip:Hide()
--    end)

lccd_widgetButton:SetScript("OnClick", function()
    if lccd_widget:IsVisible() then
        lccd_usercache['WidgetnotVisible'] = true
        lccd_widget:Hide()
        lccd_widgetButton:SetHeight(20)
        lccd_widgetButton:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfnopen.tga")
        lccd_widgetButton:SetPushedTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopen.tga")
        lccd_widgetButton:SetHighlightTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopen.tga")
    else
        lccd_usercache['WidgetnotVisible'] = false
        lccd_widget:Show()
        lccd_widgetButton:SetHeight(lccd_widget:GetHeight())
        lccd_widgetButton:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfnopenl.tga")
        lccd_widgetButton:SetPushedTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")
        lccd_widgetButton:SetHighlightTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")
    end
end)


if GetLocale() == "frFR"
then
	lccd_skilltayloringtxt = "Couture"
	lccd_skillalchemytxt = "Alchimie"
	lccd_saltsshaker = "Tamis à sel"
	lccd_mcdremaining = "Temps de recharge restant"
	lccd_printopentxt="Afficher les temps de recharge pour la fenêtre d'occupation actuelle."
	lccd_printlogintxt="Afficher les temps de recharge après la connexion."
	lccd_printonreadytxt="Afficher les temps de recharge dès qu'ils sont prêts."
	lccd_shakescantxt="Balayez toujours la salière."
	lccd_displayicontxt="Afficher l'icône d'état."
	lccd_tdisplayicontxt="Pour les utilisateurs de Titan Panel: déplacez légèrement l'icône vers le bas."
	lccd_freeiconmovetxt="Déplacer librement le symbole d'état."
	lccd_ignoredcooldownstxt='Temps de recharge ignorés'
    lccd_ignoredusercooldownstxt = UnitName("player")
	lccd_ignoredglobalcooldownstxt='Tous les caractères'
	lccd_resetcachetxt='Vider le cache des personnages'
	lccd_helptext1=" /ccd - Réglages"
	lccd_helptext2=" /ccd demo - Démonstration de la sortie"
	lccd_helptext3=" /ccd help - Cela montre que l'aide"
	lccd_helptext4=" /ccd p - Afficher les temps de recharge"
	lccd_lcraftcooldownstxt="Temps de recharge de l'emploi:\n"
	lccd_addedtxt="Ajoutée"
	lccd_readyouttxt="!PRÊT!"
    lccd_printopentooltip = "Affiche les temps de recharge de l'occupation actuelle lorsque la fenêtre d'occupation est ouverte."
    lccd_printlogintooltip = "Affiche tous les temps de recharge lors de la connexion."
    lccd_printonreadytooltip = "Affiche un rappel dès qu'un temps de recharge est prêt."
    lccd_shakescantooltip = "Empoignez et retirez le scan de la salière."
    lccd_displayicontooltip = "Afficher ou masquer l'icône d'état. "
    lccd_tdisplayicontooltip = "Déplace l'icône d'état un peu vers le bas à partir du coin supérieur gauche de l'écran (aide également si vous avez accidentellement déplacé l'icône d'état hors de la zone visible de l'écran)."
    lccd_freeiconmovetooltip = "Permet à l'icône d'état d'être déplacée librement avec la souris."
    lccd_resetcachetooltip = "Efface les données du caractère actuel. C'est utile si, par exemple, vous ne souhaitez plus suivre les temps de récupération du personnage."
    lccd_ignoredcooldownstooltip = "Dans cette liste, vous pouvez retirer les temps de recharge de ce personnage de la surveillance. Cela ne s'applique qu'à ce personnage et n'a aucune influence sur l'icône d'état, mais uniquement sur l'info-bulle et les notifications."
    lccd_ignoredglobalcooldownstooltip = "Les temps de recharge globaux ignorés ici ne sont affichés sur aucun personnage et leur statut est ignoré par l'icône d'état."
    lccd_resetcignoredtxt = "Reset"
    lccd_resetGignoredtooltip = "Réinitialisez la liste globale des temps de recharge ignorés."
    lccd_resetCignoredtooltip = "Les listes de temps de recharge ignorés pour ce personnage seront réinitialisées."
	lccd_SizeCDIcontxt = "Agrandissement de l'icône pour un temps de recharge prêt "
	lccd_SizeCDIcontooltip = "Agrandissez l'icône de temps de recharge pour un temps de recharge expiré du personnage actuel."
    lccd_DoubleSizeIcontxt = "Agrandissement des icônes pour les écrans haute résolution."
	lccd_DoubleSizeIcontooltip = "Les icônes sont affichées un peu agrandies. Utile pour les écrans haute résolution."
    lccd_Mainoptstxt = "Principales options"
    lccd_gcdfiltertxt = "Recherchez les temps de recharge."
    lccd_txt_ttdisableg = "\n\nDésactiver globalement?"
    lccd_txt_ttdisableu1 = "\n\nDésactiver uniquement pour "
    lccd_txt_ttdisableu2 = "?"
    lccd_txt_ttremovecd = "\n\nSupprimer ce temps de recharge?\n(cela ne peut pas être inversé!)"
    lccd_ignoreselectedcooldownstxt = 'Sélectionnez les cooldowns affichés.'
	lccd_unignoreselectedcooldownstxt='Désélectionnez les cooldowns affichés.'
    lccd_allrealmstxt = "Tous les royaumes"
    lccd_allprofstxt = "Toutes les professions"
    lccd_allskills = "Toutes les compétences"
    lccd_realmtxt = "Royaume"
    lccd_professiontxt = "Profession"
    lccd_skilltxt = "Compétence"
    lccd_txt_ncdready = "Aucun temps de recharge prêt"
    lccd_txt_ShowWidget = "Afficher le widget de temps de recharge."
    lccd_txt_ShowWidgettt = "Affiche ou masque le widget de récupération."
    lccd_txt_MoveWidget = "Widget frei bewegen"
    lccd_txt_MoveWidgettt = "Le widget de récupération peut être positionné librement. Pour le fixer dans la nouvelle position simplement désactiver cette option après le positionnement.\n\nLorsqu'il est désactivé, le widget ne réagit pas à la souris et aucune info-bulle n'est alors affichée."
    lccd_txt_ResetWidget = "Réinitialise la position du widget de récupération."
    lccd_txt_Small = "Petit"
    lccd_txt_Smalltt = "Petit widget de temps de recharge."
    lccd_txt_Normal = "Normal"
    lccd_txt_Normaltt = "Widget de refroidissement normal."
    lccd_txt_Big = "Grand"
    lccd_txt_Bigtt = "Grand widget de temps de recharge."
    lccd_txt_WidgetSizeSet = "Paramètres de taille de widget:"
elseif GetLocale() == "deDE"
then
	lccd_skilltayloringtxt = "Schneiderei"
	lccd_skillalchemytxt = "Alchimie"
	lccd_saltsshaker = "Salzstreuer"
	lccd_mcdremaining = "Verbleibende Abklingzeit: "
	lccd_printopentxt="Cooldowns für das aktuelle Berufefenster anzeigen."
	lccd_printlogintxt="Cooldowns nach dem Einloggen anzeigen."
	lccd_printonreadytxt="Cooldowns anzeigen, sobald sie bereit sind."
	lccd_shakescantxt="Immer den Salzstreuer scannen."
	lccd_displayicontxt="Statusicon anzeigen."
	lccd_tdisplayicontxt="Für Titanpanelbenutzer: Icon etwas nach unten verschieben."
	lccd_freeiconmovetxt="Statusicon frei bewegen."
	lccd_ignoredcooldownstxt='Ignorierte Cooldowns'
    lccd_ignoredusercooldownstxt = UnitName("player")
	lccd_ignoredglobalcooldownstxt='Alle Charaktere'
	lccd_resetcachetxt='Charaktercache löschen'
	lccd_helptext1=" /ccd - Einstellungen"
	lccd_helptext2=" /ccd demo - Demonstration der Ausgabe"
	lccd_helptext3=" /ccd help - zeigt diese Hilfe"
	lccd_helptext4=" /ccd p - Cooldowns anzeigen"
	lccd_lcraftcooldownstxt="Cooldowns für Berufe:\n"
	lccd_addedtxt="Hinzugefügt"
	lccd_readyouttxt="!BEREIT!"
    lccd_printopentooltip = "Zeigt die Cooldowns für den aktuellen Beruf, wenn das Berufefenster geöffnet wird."
    lccd_printlogintooltip = "Zeigt alle Cooldowns beim Einloggen."
    lccd_printonreadytooltip = "Zeigt eine Erinnerung an sobald ein Cooldown bereit ist."
    lccd_shakescantooltip = "Sachltet den Salzstreuerscan ein und aus."
    lccd_displayicontooltip = "Statusicon ein- oder ausblenden."
    lccd_tdisplayicontooltip = "Bewegt das Statusicon ein Stück runter aus der oberen linken Ecke des Bildschirms (hilft auch wenn man aus versehen das Statusicon aus dem sichtbaren Bereich des Bildschirms bewegt hat)."
    lccd_freeiconmovetooltip = "Erlaubt das Statusicon mit der Maus frei zu bewegen."
    lccd_resetcachetooltip = "Löscht die Daten für den aktuellen Charakter. Es ist hilfreich wenn man z.B. die Cooldowns für den Charakter nicht mehr verfolgen möchte."
    lccd_ignoredcooldownstooltip = "In dieser Liste kann man die Cooldowns dieses Charakters aus der Überwachung raus nehmen. Dis gilt nur für diesen Charakter und hat keinen Einfluss auf das Statusicon, sondern nur auf den Tooltip und die Benachrichtigungen."
    lccd_ignoredglobalcooldownstooltip = "Hier Ignorierte Cooldowns werden auf keinem Charakter angezeigt und deren Status wird vom Statusicon ignoriert."
    lccd_resetcignoredtxt = "Reset"
    lccd_resetGignoredtooltip = "Globale Liste ignorierter Cooldowns wird geleert."
    lccd_resetCignoredtooltip = "Liste ignorierter Cooldowns für diesen charakter wird geleert."
   	lccd_SizeCDIcontxt = "Iconvergrößerung für einen bereiten Cooldown"
	lccd_SizeCDIcontooltip = "Den Cooldownicon für einen abgelaufenen Cooldown des aktuellen Charakters vergrößern."
    lccd_DoubleSizeIcontxt = "Iconvergrößerung für hochauflösende Displays."
	lccd_DoubleSizeIcontooltip = "Cooldownicons werden etwas vergrößert dargestellt. Hilfreich bei hochauflösenden Displays."
    lccd_Mainoptstxt = "Allgemeine Einstellungen"
    lccd_gcdfiltertxt = "Cooldowns suchen."
    lccd_txt_ttdisableg = "\n\nGlobal deaktivieren?"
    lccd_txt_ttdisableu1 = "\n\nNur für "
    lccd_txt_ttdisableu2 = " deaktivieren?"
    lccd_txt_ttremovecd = "\n\nDiesen Cooldown löschen?\n(dies kann nicht rückgängig gemacht werden!)"
    lccd_ignoreselectedcooldownstxt = 'Die angezeigten Cooldowns auswählen.'
	lccd_unignoreselectedcooldownstxt='Die angezeigten Cooldowns abwählen.'
    lccd_allrealmstxt = "Alle Realms"
    lccd_allprofstxt = "Alle Berufe"
    lccd_allskills = "Alle Fertigkeiten"
    lccd_realmtxt = "Realm"
    lccd_professiontxt = "Beruf"
    lccd_skilltxt = "Fertigkeit"
    lccd_txt_ncdready = "Keine Cooldowns bereit"
    lccd_txt_ShowWidget = "Widget anzeigen."
    lccd_txt_ShowWidgettt = "Zeigt das Cooldownwidget an, oder versteckt es."
    lccd_txt_MoveWidget = "Widget frei bewegen."
    lccd_txt_MoveWidgettt = "Das Cooldownwidget kann frei positioniert werden. Um es an der neuen Position zu fixieren einfach nach der Positionierung diese Option deaktivieren.\n\nFestgesetzt reagiert das widget nicht auf die Maus. Es wird dann kein Tooltip angezeigt."
    lccd_txt_ResetWidget = "Setzt die Position des Cooldownwidgets zurück."
    lccd_txt_Small = "Klein"
    lccd_txt_Smalltt = "Kleine Cooldownwidgetanzeige."
    lccd_txt_Normal = "Normal"
    lccd_txt_Normaltt = "Normale Cooldownwidgetanzeige."
    lccd_txt_Big = "Groß"
    lccd_txt_Bigtt = "Große Cooldownwidgetanzeige."
    lccd_txt_WidgetSizeSet = "Einstellungen zur Widgetgröße:"
else
	lccd_skilltayloringtxt = "Tailoring"
	lccd_skillalchemytxt = "Alchemy"
	lccd_saltsshaker = "Salt Shaker"
	lccd_mcdremaining = "Cooldown remaining: "
	lccd_printopentxt="Print cooldowns for the current profession window."
	lccd_printlogintxt="Print cooldowns on login"
	lccd_printonreadytxt="Print cooldowns when ready"
	lccd_shakescantxt="Always scan the salt shaker."
	lccd_displayicontxt="Show status icon."
	lccd_tdisplayicontxt="For Titan Panel users: move the icon down a little."
	lccd_freeiconmovetxt="Enable free icon positioning."
	lccd_ignoredcooldownstxt='Ignored Cooldowns'
    lccd_ignoredusercooldownstxt = UnitName("player")
	lccd_ignoredglobalcooldownstxt='All characters'
	lccd_resetcachetxt='Clear character cache'
	lccd_helptext1=" /ccd - options"
	lccd_helptext2=" /ccd demo - color scheme demo"
	lccd_helptext3=" /ccd help - help"
	lccd_helptext4=" /ccd p - print cooldowns"
	lccd_lcraftcooldownstxt="Crafting Cooldowns:\n"
	lccd_addedtxt="Added"
	lccd_readyouttxt="!READY!"
    lccd_printopentooltip = "Prints cooldowns for the currently opened profession window."
    lccd_printlogintooltip = "Shows cooldowns on login."
    lccd_printonreadytooltip = "Shows cooldown reminder when they are ready."
    lccd_shakescantooltip = "Turns the salt shaker scan on and off."
    lccd_displayicontooltip = "Enable and disable the status icon."
    lccd_tdisplayicontooltip = "Move the status icon a little bit down from the left upper corner (helps if the icon was moved outside the screen)."
    lccd_freeiconmovetooltip = "Enable the mouse movement for the status icon."
    lccd_resetcachetooltip = "Clears the data for the current character. It is helpful if, for example, you no longer want to follow the cooldowns for the character. "
    lccd_ignoredcooldownstooltip = "In this list you can take the cooldowns of this character out of the surveillance. This only applies to this character and has no influence on the status icon, but only on the tooltip and the notifications."
    lccd_ignoredglobalcooldownstooltip = "Ignored global cooldowns are not displayed on any character and their status is ignored by the status icon."
    lccd_resetcignoredtxt = "Reset"
    lccd_resetGignoredtooltip = "Reset for the global list of ignored cooldowns."
    lccd_resetCignoredtooltip = "Lists of ignored cooldowns for this character will be reset."
   	lccd_SizeCDIcontxt = "Icon enlargement for a ready cooldown."
	lccd_SizeCDIcontooltip = "Enlarge the cooldown icon for an expired cooldown of the current character."
    lccd_DoubleSizeIcontxt = "Icon enlargement for high resolution displays."
	lccd_DoubleSizeIcontooltip = "Cooldown icons are shown enlarged. Useful for high-resolution displays."
    lccd_Mainoptstxt = "Main options"
    lccd_gcdfiltertxt = "Search cooldowns."
    lccd_txt_ttdisableg = "\n\nDisable for all characters?"
    lccd_txt_ttdisableu1 = "\n\nDisable for "
    lccd_txt_ttdisableu2 = " only?"
    lccd_txt_ttremovecd = "\n\nDelete this cooldown?\n(this cannot be reversed!)"
    lccd_ignoreselectedcooldownstxt = 'Select the displayed cooldowns.'
	lccd_unignoreselectedcooldownstxt='Deselect the displayed cooldowns.'
    lccd_allrealmstxt = "All realms"
    lccd_allprofstxt = "All Professions"
    lccd_allskills = "All Skills"
    lccd_realmtxt = "Realm"
    lccd_professiontxt = "Profession"
    lccd_skilltxt = "Skill"
    lccd_txt_ncdready = "No cooldowns ready"
    lccd_txt_ShowWidget = "Show the cooldown widget."
    lccd_txt_ShowWidgettt = "Shows or hides the cooldown widget."
    lccd_txt_MoveWidget = "Make widget movable."
    lccd_txt_MoveWidgettt = "The cool down widget can be positioned freely. To fix it in the new position simply deactivate this option after positioning.\n\nWhen deactivated, the widget does not react to the mouse and no tooltip is then displayed. "
    lccd_txt_ResetWidget = "Resets the position of the cool down widget."
    lccd_txt_Small = "Small"
    lccd_txt_Smalltt = "Small cooldown widget."
    lccd_txt_Normal = "Normal"
    lccd_txt_Normaltt = "Normal cooldown widget."
    lccd_txt_Big = "Big"
    lccd_txt_Bigtt = "Big cooldown widget."
    lccd_txt_WidgetSizeSet = "Widget size settings:"
end

local lccd_mainopts = lccd_options.main
lccd_mainopts.name = addonName
lccd_mainopts:Hide()
lccd_mainopts:SetScript("OnShow", function(lccd_mainopts)

	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "CCDCheck" .. label, lccd_mainopts, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = description
		check.tooltipRequirement = ""
		return check
	end

	local title = lccd_mainopts:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addonName .. " -- v." .. addonVersion .. " - " .. lccd_Mainoptstxt)

	local printOnOpen = newCheckbox(
		lccd_printopentxt,
		lccd_printopentooltip,
		function(self, value) lccd_usercache['config']['onOpen'] = value end)
	printOnOpen:SetChecked(lccd_usercache['config']['onOpen'])
	printOnOpen:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -2, -16)

	local printOnLogin = newCheckbox(
		lccd_printlogintxt,
		lccd_printlogintooltip,
		function(self, value) lccd_usercache['config']['onLogin'] = value end)
	printOnLogin:SetChecked(lccd_usercache['config']['onLogin'])
	printOnLogin:SetPoint("TOPLEFT", printOnOpen, "BOTTOMLEFT", 0, 0)

	local printOnReady = newCheckbox(
		lccd_printonreadytxt,
		lccd_printonreadytooltip,
		function(self, value) lccd_usercache['config']['onReady'] = value end)
	printOnReady:SetChecked(lccd_usercache['config']['onReady'])
	printOnReady:SetPoint("TOPLEFT", printOnLogin, "BOTTOMLEFT", 0, 0)
    
    local shakescan = nil
    
    if (lccd_wowv < 3) then
        shakescan = newCheckbox(
            lccd_shakescantxt,
            lccd_shakescantooltip,
            function(self, value) lccd_usercache['config']['saltshakescan'] = value end)
        shakescan:SetChecked(lccd_usercache['config']['onReady'])
        shakescan:SetPoint("TOPLEFT", printOnReady, "BOTTOMLEFT", 0, 0)
    end
	
	local showDisplayIcon = newCheckbox(
		lccd_displayicontxt,
		lccd_displayicontooltip,
		function(self, value) 
		    lccd_usercache['config']['DisplayIcon'] = value
            if value
            then
                ssdisp:Show()
            else
                ssdisp:Hide()
            end
		end)
	showDisplayIcon:SetChecked(lccd_usercache['config']['DisplayIcon'])
	if (lccd_wowv < 3) then
        showDisplayIcon:SetPoint("TOPLEFT", shakescan, "BOTTOMLEFT", 0, 0)
    else
        showDisplayIcon:SetPoint("TOPLEFT", printOnReady, "BOTTOMLEFT", 0, 0)
    end

	local titanDisplayIcon = newCheckbox(
		lccd_tdisplayicontxt,
		lccd_tdisplayicontooltip,
		function(self, value) 
		    lccd_globalCache['tDisplayIcon'] = value
            if (lccd_wowv == 2 or lccd_wowv == 3) then
                if value
                then
                    ssdisp:SetPoint("TOPLEFT", 5, -66)
                else
                    ssdisp:SetPoint("TOPLEFT", 5, -5)
                end
            else
                if value
                then
                    ssdisp:SetPoint("TOPLEFT", 2, -66)
                else
                    ssdisp:SetPoint("TOPLEFT", 2, -2)
                end
            end
		end)
	titanDisplayIcon:SetChecked(lccd_globalCache['tDisplayIcon'])
	titanDisplayIcon:SetPoint("TOPLEFT", showDisplayIcon, "BOTTOMLEFT", 10, 0)
	
	local FreeIconMove = newCheckbox(
		lccd_freeiconmovetxt,
		lccd_freeiconmovetooltip,
		function(self, value) 
		    lccd_usercache['fIconMove'] = value
            if value
            then
                lccd_moveicon(true)
            else
                lccd_moveicon(false)
            end
		end)
	FreeIconMove:SetChecked(lccd_usercache['fIconMove'])
	FreeIconMove:SetPoint("TOPLEFT", titanDisplayIcon, "BOTTOMLEFT", 0, 0)

	local SizeCDIcon = newCheckbox(
		lccd_SizeCDIcontxt,
		lccd_SizeCDIcontooltip,
		function(self, value) 
		    lccd_usercache['IconResize'] = value
		end)
	SizeCDIcon:SetChecked(lccd_usercache['IconResize'])
	SizeCDIcon:SetPoint("TOPLEFT", FreeIconMove, "BOTTOMLEFT", 0, 0)
    
	local DoubleSizeCDIcon = newCheckbox(
		lccd_DoubleSizeIcontxt,
		lccd_DoubleSizeIcontooltip,
		function(self, value) 
		    lccd_globalCache['IconDoubleSize'] = value
            if value
            then
                ssdisp:SetWidth(24)
                ssdisp:SetHeight(24)

                ssdisp1:SetWidth(14)
                ssdisp1:SetHeight(14)

                ssdisp2:SetWidth(14)
                ssdisp2:SetHeight(14)

                ssdisp3:SetWidth(14)
                ssdisp3:SetHeight(14)

                ssdisp4:SetPoint("TOPRIGHT", ssdisp, "TOPRIGHT", 5, 5)
                ssdisp4:SetWidth(14)
                ssdisp4:SetHeight(14)

                ssdisp5:SetWidth(14)
                ssdisp5:SetHeight(14)
                
                ssdisp6:SetWidth(14)
                ssdisp6:SetHeight(14)

                ssdisp3ap:SetWidth(24)
                ssdisp3ap:SetHeight(24)
                if (lccd_wowv == 2 or lccd_wowv == 3) then
                    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -5, 5)
                    ssdisp2:SetPoint("BOTTOMRIGHT", ssdisp, "BOTTOMRIGHT", 5, -5)
                    ssdisp3:SetPoint("BOTTOMLEFT", ssdisp, "BOTTOMLEFT", -5, -5)
                    ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, -5)
                else
                    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
                    ssdisp2:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", 15, 3)
                    ssdisp3:SetPoint("CENTER", ssdisp, "CENTER", 0, -7)
                end
            else
                ssdisp:SetWidth(16)
                ssdisp:SetHeight(16)

                ssdisp1:SetWidth(9)
                ssdisp1:SetHeight(9)

                ssdisp2:SetWidth(9)
                ssdisp2:SetHeight(9)

                ssdisp3:SetWidth(9)
                ssdisp3:SetHeight(9)

                ssdisp4:SetPoint("TOPRIGHT", ssdisp, "TOPRIGHT", 3, 3)
                ssdisp4:SetWidth(9)
                ssdisp4:SetHeight(9)

                ssdisp5:SetWidth(9)
                ssdisp5:SetHeight(9)

                ssdisp6:SetWidth(9)
                ssdisp6:SetHeight(9)

                ssdisp3ap:SetWidth(16)
                ssdisp3ap:SetHeight(16)
                if (lccd_wowv == 2 or lccd_wowv == 3) then
                    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
                    ssdisp2:SetPoint("BOTTOMRIGHT", ssdisp, "BOTTOMRIGHT", 3, -3)
                    ssdisp3:SetPoint("BOTTOMLEFT", ssdisp, "BOTTOMLEFT", -3, -3)
                    ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, -3)
                else
                    ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -2, 2)
                    ssdisp2:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", 10, 2)
                    ssdisp3:SetPoint("CENTER", ssdisp, "CENTER", 0, -5)
                end
            end
		end)
	DoubleSizeCDIcon:SetChecked(lccd_globalCache['IconDoubleSize'])
	DoubleSizeCDIcon:SetPoint("TOPLEFT", SizeCDIcon, "BOTTOMLEFT", 0, 0)

	local resetButton = CreateFrame("Button", "ResetButtonFrame", lccd_mainopts, "UIPanelButtonTemplate")
	resetButton:SetPoint("TOPLEFT", DoubleSizeCDIcon, "BOTTOMLEFT", 0, -8)
	resetButton:SetScript("OnClick", function()
		    lccd_clearCharacterCache()
	    end)
	resetButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(resetButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText(lccd_resetcachetooltip, nil, nil, nil, nil, 1);
	    end)
	resetButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	resetButton:SetText(lccd_resetcachetxt)
	resetButton:SetWidth(200)


	local showWidget = newCheckbox(
		lccd_txt_ShowWidget,
		lccd_txt_ShowWidgettt,
		function(self, value) 
		    lccd_usercache['WidgetShow'] = value
            if value
            then
                lccd_widgetButton:Show()
            else
                lccd_widgetButton:Hide()
            end
		end)
	showWidget:SetChecked(lccd_usercache['WidgetShow'])
	showWidget:SetPoint("TOPLEFT", resetButton, "BOTTOMLEFT", -10, -8)

	local MoveWidget = newCheckbox(
		lccd_txt_MoveWidget,
		lccd_txt_MoveWidgettt,
		function(self, value) 
		    lccd_usercache['fWidgetMove'] = value
            if value
            then
                lccd_movewidget(true)
            else
                lccd_movewidget(false)
            end
		end)
	MoveWidget:SetChecked(lccd_usercache['fWidgetMove'])
	MoveWidget:SetPoint("TOPLEFT", showWidget, "BOTTOMLEFT", 0, 0)

	local WidgetresetButton = CreateFrame("Button", "ResetButtonFrame", lccd_mainopts, "UIPanelButtonTemplate")
	WidgetresetButton:SetPoint("LEFT", MoveWidget, "RIGHT", 250, 0)
	WidgetresetButton:SetScript("OnClick", function()
            lccd_usercache['WidgetPosrel'] = "LEFT"
            lccd_usercache['WidgetPosx'] = 0
            lccd_usercache['WidgetPosy'] = 0
            lccd_widgetButton:ClearAllPoints()
		    lccd_widgetButton:SetPoint(lccd_usercache['WidgetPosrel'], lccd_usercache['WidgetPosx'], lccd_usercache['WidgetPosy'])
            lccd_usercache['WidgetnotVisible'] = false
            lccd_widget:Show()
            lccd_widgetButton:SetHeight(lccd_widget:GetHeight())
            lccd_widgetButton:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfnopenl.tga")
            lccd_widgetButton:SetPushedTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")
            lccd_widgetButton:SetHighlightTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopenl.tga")
	    end)
	WidgetresetButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(WidgetresetButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText(lccd_txt_ResetWidget, nil, nil, nil, nil, 1);
	    end)
	WidgetresetButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	WidgetresetButton:SetText(lccd_resetcignoredtxt)
	WidgetresetButton:SetWidth(80)

	local WidgetSizeTitle = lccd_mainopts:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	WidgetSizeTitle:SetPoint("TOPLEFT", MoveWidget, "BOTTOMLEFT", 0, -8)
	WidgetSizeTitle:SetText("|cffFFFFFF" .. lccd_txt_WidgetSizeSet .. "|r")

    local WidgetNormal = nil
    local WidhetBig = nil
    local WidgetSmall = nil
	
    WidgetSmall = newCheckbox(
		lccd_txt_Small,
		lccd_txt_Smalltt,
		function(self, value) 
            lccd_widgetButton:SetScale(0.75)
            lccd_usercache['WidgetSize'] = 0.75
            if value
            then
                WidgetNormal:SetChecked(false)
                WidgetBig:SetChecked(false)
            else
                WidgetSmall:SetChecked(true)
            end
		end)
    if lccd_usercache['WidgetSize'] == 0.75 then
        WidgetSmall:SetChecked(true)
    end
	WidgetSmall:SetPoint("TOPLEFT", WidgetSizeTitle, "BOTTOMLEFT", 0, -16)
    
	WidgetNormal = newCheckbox(
		lccd_txt_Normal,
		lccd_txt_Normaltt,
		function(self, value)
            lccd_widgetButton:SetScale(1)
            lccd_usercache['WidgetSize'] = 1
            if value
            then
                WidgetSmall:SetChecked(false)
                WidgetBig:SetChecked(false)
            else
                WidgetNormal:SetChecked(true)
            end
		end)
    if lccd_usercache['WidgetSize'] == 1 then
        WidgetNormal:SetChecked(true)
    end
	WidgetNormal:SetPoint("LEFT", WidgetSmall, "RIGHT", 100, 0)

	WidgetBig = newCheckbox(
		lccd_txt_Big,
		lccd_txt_Bigtt,
		function(self, value) 
            lccd_widgetButton:SetScale(1.5)
            lccd_usercache['WidgetSize'] = 1.5
            if value
            then
                WidgetSmall:SetChecked(false)
                WidgetNormal:SetChecked(false)
            else
                WidgetBig:SetChecked(true)
            end
		end)
    if lccd_usercache['WidgetSize'] == 1.5 then
        WidgetBig:SetChecked(true)
    end
	WidgetBig:SetPoint("LEFT", WidgetNormal, "RIGHT", 100, 0)

	lccd_mainopts:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(lccd_options.main)


lccd_options.owncd = CreateFrame("Frame")
lccd_options.owncd.name = lccd_ignoredcooldownstxt
lccd_options.owncd.parent = lccd_options.main.name
local lccd_ignoredopts = lccd_options.owncd
lccd_ignoredopts:Hide()

local lccd_globalcdentry = {}
local lccd_globalcdcheck = {}
local lccd_usercdcheck = {}
local lccd_removecd = {}
local lccd_globalcdentrybg = {}

local lccd_globalcdscrollframechild = CreateFrame("Frame", "LCCD_Global-Ignores-select", UIparent, BackdropTemplateMixin and "BackdropTemplate")
lccd_globalcdscrollframechild:Hide()
local function lccd_globalcdlist()
    local lccd_globalcdcount = 0

    local lccd_globalentrycount = 0
    for _, entry in pairs(lccd_globalcdentry)
    do
        lccd_globalcdentry[lccd_globalentrycount]:Hide()
        lccd_globalentrycount = lccd_globalentrycount + 1  
    end

    local lccd_globalentrybgcount = 0
    for _, entry in pairs(lccd_globalcdentrybg)
    do
        lccd_globalcdentrybg[lccd_globalentrybgcount]:Hide()
        lccd_globalentrybgcount = lccd_globalentrybgcount + 1  
    end

    local lccd_globalbuttoncount = 0
    for _, entry in pairs(lccd_globalcdcheck)
    do
        lccd_globalcdcheck[lccd_globalbuttoncount]:Hide()
        lccd_globalbuttoncount = lccd_globalbuttoncount + 1  
    end

    local lccd_userbuttoncount = 0
    for _, entry in pairs(lccd_usercdcheck)
    do
        lccd_usercdcheck[lccd_userbuttoncount]:Hide()
        lccd_userbuttoncount = lccd_userbuttoncount + 1  
    end
    
    local lccd_removecdcount = 0
    for _, entry in pairs(lccd_removecd)
    do
        lccd_removecd[lccd_removecdcount]:Hide()
        lccd_removecdcount = lccd_removecdcount + 1  
    end

    local lccd_filtertable = {}
    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
            if (lccd_gdcfilterrealm == "") or (entry['realm'] == lccd_gdcfilterrealm) then
                if (lccd_gdcfilterprof == "") or (entry['profession'] == lccd_gdcfilterprof) then
                    if (lccd_gdcfilterskill == "") or (entry['cooldown'] == lccd_gdcfilterskill) then
                        table.insert(lccd_filtertable, entry)
                    end
                end
            end
        end
    end

    for _, entry in pairs(lccd_filtertable)
    do
        local cditemlink = entry['seconds']['scitemid']
        local texture = ""
        local texturett = ""
        if cditemlink == nil
            then
            texture = "     "
            texturett = ""
        else
            if GetItemIcon(cditemlink) ~= nil
                then

                if cditemlink == 28028
                    then
                    cditemlink = 22459
                end
                if cditemlink == 28027
                    then
                    cditemlink = 22460
                end
                
                if cditemlink == 61288 or cditemlink == 61177 then
                    texture = "|T" .. 237171 .. " :15:15:0:0|t    "
                    texturett = "|T" .. 237171 .. " :24:24:0:0|t "
                else
                    texture = "|T" .. GetItemIcon(cditemlink) .. " :15:15:0:0|t    "
                    texturett = "|T" .. GetItemIcon(cditemlink) .. " :24:24:0:0|t "
                end
            end
        end

        if lccd_globalcdentry[lccd_globalcdcount] == nil
            then
            lccd_globalcdcheck[lccd_globalcdcount] = CreateFrame("CheckButton", nil, lccd_globalcdscrollframechild, "UICheckButtonTemplate")
            lccd_globalcdcheck[lccd_globalcdcount]:SetSize(26, 26)
            lccd_globalcdcheck[lccd_globalcdcount]:SetPoint("TOPLEFT", 57, (lccd_globalcdcount * (-20)))
            local globalckbutton = lccd_globalcdcheck[lccd_globalcdcount]
            lccd_usercdcheck[lccd_globalcdcount] = CreateFrame("CheckButton", nil, lccd_globalcdscrollframechild, "UICheckButtonTemplate")
            lccd_usercdcheck[lccd_globalcdcount]:SetSize(26, 26)
            lccd_usercdcheck[lccd_globalcdcount]:SetPoint("RIGHT", globalckbutton, "LEFT", -1, 0)
            
            lccd_removecd[lccd_globalcdcount] = CreateFrame("Button", nil, lccd_globalcdscrollframechild, "OptionsButtonTemplate")
            lccd_removecd[lccd_globalcdcount]:SetPoint("RIGHT", globalckbutton, "LEFT", -31, 0)
            lccd_removecd[lccd_globalcdcount]:SetSize(20, 21)
            lccd_removecd[lccd_globalcdcount]:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/trash")
            
            lccd_globalcdentrybg[lccd_globalcdcount] = CreateFrame("Frame", nil, lccd_globalcdscrollframechild)
            lccd_globalcdentrybg[lccd_globalcdcount]:SetSize(435, 21)
            lccd_globalcdentrybg[lccd_globalcdcount]:SetPoint("LEFT", globalckbutton, "RIGHT", 5, 0)
            
            lccd_globalcdentry[lccd_globalcdcount] = lccd_globalcdentrybg[lccd_globalcdcount]:CreateFontString(nil, "ARTWORK", "GameFontNormal")
            lccd_globalcdentry[lccd_globalcdcount]:SetPoint("LEFT", 0, 0)
        end
        lccd_globalcdentry[lccd_globalcdcount]:SetText(texture .. (lccd_globalcdcount + 1).. "). " .. entry['name'])
        lccd_globalcdentry[lccd_globalcdcount]:Show()
        lccd_globalcdentrybg[lccd_globalcdcount]:Show()

        lccd_globalcdcheck[lccd_globalcdcount]:SetScript("OnClick", function(self)
            lccd_toggleIgnoreGlobalCooldown(entry['name'])
        end)
        
        lccd_usercdcheck[lccd_globalcdcount]:SetScript("OnClick", function(self)
            lccd_toggleIgnoreUserCooldown(entry['name'])
        end)

        lccd_removecd[lccd_globalcdcount]:SetScript("OnClick", function(self)
            print(lccd_globalCache['crafts1'][entry['realm']][entry['char']][entry['seconds']['scitemid']]["name"])
            lccd_globalCache['crafts1'][entry['realm']][entry['char']][entry['seconds']['scitemid']] = nil
            lccd_globalcdlist()
            lccd_ignoredcleanup()
        end)

        local ttentrygdc = lccd_globalcdcheck[lccd_globalcdcount]
        local _, ttitemlink = GetItemInfo(cditemlink)

        if cditemlink == 61288 or cditemlink == 61177 then
            ttitemlink = GetSpellLink(cditemlink)
        end

        ttentrygdc:SetScript("OnEnter", function(self, motion)
                GameTooltip:SetOwner(ttentrygdc, "ANCHOR_TOPLEFT");
                GameTooltip:SetText((texturett .. ttitemlink), nil, nil, nil, nil, 1);
                GameTooltip:AddLine((entry['name'] .. lccd_txt_ttdisableg), 1, 0.8, 0)
                GameTooltip:Show()
            end)
        ttentrygdc:SetScript("OnLeave", function(self, motion)
                GameTooltip:Hide()
            end)
            
        local ttentryudc = lccd_usercdcheck[lccd_globalcdcount]
        ttentryudc:SetScript("OnEnter", function(self, motion)
                GameTooltip:SetOwner(ttentryudc, "ANCHOR_TOPLEFT");
                GameTooltip:SetText((texturett .. ttitemlink), nil, nil, nil, nil, 1);
                GameTooltip:AddLine((entry['name'] .. lccd_txt_ttdisableu1 .. UnitName("player") .. lccd_txt_ttdisableu2), 1, 0.8, 0)
                GameTooltip:Show()
            end)
        ttentryudc:SetScript("OnLeave", function(self, motion)
                GameTooltip:Hide()
            end)

        local ttremove = lccd_removecd[lccd_globalcdcount]
        ttremove:SetScript("OnEnter", function(self, motion)
                GameTooltip:SetOwner(ttremove, "ANCHOR_TOPLEFT");
                GameTooltip:SetText((texturett .. ttitemlink), nil, nil, nil, nil, 1);
                GameTooltip:AddLine((entry['name'] .. lccd_txt_ttremovecd), 1, 0.8, 0)
                GameTooltip:Show()
            end)
        ttremove:SetScript("OnLeave", function(self, motion)
                GameTooltip:Hide()
            end)

        local ttentrytxt = lccd_globalcdentrybg[lccd_globalcdcount]
        ttentrytxt:SetScript("OnEnter", function(self, motion)
                GameTooltip:SetOwner(ttentrytxt, "ANCHOR_RIGHT");
                GameTooltip:SetHyperlink(ttitemlink)
            end)
        ttentrytxt:SetScript("OnLeave", function(self, motion)
                GameTooltip:Hide()
            end)

        lccd_globalcdcheck[lccd_globalcdcount]:SetChecked(lccd_isGlobalCooldownIgnored(entry['name']))
        lccd_usercdcheck[lccd_globalcdcount]:SetChecked(lccd_isUserCooldownIgnored(entry['name']))
        lccd_globalcdcheck[lccd_globalcdcount]:Show()
        lccd_usercdcheck[lccd_globalcdcount]:Show()
        lccd_removecd[lccd_globalcdcount]:Show()
        lccd_globalcdcount = lccd_globalcdcount + 1
    end
end

lccd_ignoredopts:SetScript("OnShow", function(lccd_ignoredopts)
    local title = lccd_ignoredopts:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addonName .. " -- v." .. addonVersion .. " - " .. lccd_ignoredcooldownstxt)

    local lccd_globalcdframe = CreateFrame("Frame", "LCCD_Global-Ignores", lccd_ignoredopts, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdframe:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -2, -6)
    lccd_globalcdframe:SetWidth(600)
    lccd_globalcdframe:SetHeight(520)
    lccd_globalcdframe:SetFrameStrata("DIALOG")
    lccd_globalcdframe:SetBackdrop({
        bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
        tile = true,
        edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
        edgeSize = 32,
        insets = {
            left = 11,
            right = 12,
            top = 12,
            bottom = 11,
        },
    })
    

    local lccd_globalcdfilterbg = CreateFrame("Frame", "lccd_globalcdfilterbg", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdfilterbg:SetPoint("TOPLEFT", 45, -102); lccd_globalcdfilterbg:SetWidth(195); lccd_globalcdfilterbg:SetHeight(24);
    lccd_globalcdfilterbg:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bglight",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })


    local lccd_seatchtexture = CreateFrame("Frame", "lccd_searchglass", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_seatchtexture:SetSize(16, 16)
    lccd_seatchtexture:SetPoint("RIGHT", lccd_globalcdfilterbg, "LEFT", -5, 0)
    lccd_seatchtexture:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/MG",
        tile = false,
    })
    
    local lccd_globalcdfilter = CreateFrame("EditBox", nil, lccd_globalcdfilterbg)
    lccd_globalcdfilter:SetMaxLetters(200)
    lccd_globalcdfilter:SetPoint("CENTER", 0, 0)
    lccd_globalcdfilter:SetSize(175, 24)
    lccd_globalcdfilter:SetFont(ChatFontNormal:GetFont())
    lccd_globalcdfilter:SetMultiLine(false)
    lccd_globalcdfilter:SetAutoFocus( false )

    lccd_globalcdfilter:SetScript("OnEscapePressed", function()
            lccd_globalcdfilter:ClearFocus() 
    end)
    lccd_globalcdfilter:SetScript("OnEnterPressed", function()
        lccd_globalcdfilter:ClearFocus()
        lccd_gdcfilter = lccd_globalcdfilter:GetText()
        lccd_globalcdlist()
    end)

    lccd_globalcdfilter:SetScript("OnEnter", function(self, motion)
            GameTooltip:SetOwner(lccd_globalcdfilter, "ANCHOR_TOPLEFT");
            GameTooltip:SetText(lccd_gcdfiltertxt);
        end)
    lccd_globalcdfilter:SetScript("OnLeave", function(self, motion)
            GameTooltip:Hide()
        end)



    local lccd_globalcdfilterrealm = CreateFrame("Frame", "lccd_globalcdfilterrealm", lccd_globalcdframe, "UIDropDownMenuTemplate")
    lccd_globalcdfilterrealm:SetPoint("LEFT", lccd_globalcdfilterbg, "RIGHT", -10, -1)
    lccd_globalcdfilterrealm.initialize = function()
        local dd = {}
        local _, realmtable = lccd_getfiltertable("realm")
        for i, entry in pairs(realmtable)
        do
            dd.text = entry
            dd.value = entry
            dd.notCheckable = ""
            dd.func = function(self)
                UIDropDownMenu_SetText(lccd_globalcdfilterrealm, entry)
                lccd_gdcfilterrealm = self.value
                lccd_globalcdlist()
            end
            UIDropDownMenu_AddButton(dd)
        end
        dd.text = lccd_allrealmstxt
        dd.value = ""
        dd.notCheckable = ""
        dd.func = function(self)
            UIDropDownMenu_SetText(lccd_globalcdfilterrealm, lccd_allrealmstxt)
            lccd_gdcfilterrealm = ""
            lccd_globalcdlist()
        end
        UIDropDownMenu_AddButton(dd)
    end

    lccd_globalcdfilterrealm:SetScript("OnEnter", function(self, motion)
            GameTooltip:SetOwner(lccd_globalcdfilterrealm, "ANCHOR_TOPLEFT");
            local ttfilterrealm = lccd_gdcfilterrealm
            if lccd_gdcfilterrealm == "" then
                ttfilterrealm = lccd_allrealmstxt
            end
            GameTooltip:SetText(lccd_realmtxt .. ": " .. ttfilterrealm);
        end)
    lccd_globalcdfilterrealm:SetScript("OnLeave", function(self, motion)
            GameTooltip:Hide()
        end)

    UIDropDownMenu_SetWidth(lccd_globalcdfilterrealm, 90)
    UIDropDownMenu_SetText(lccd_globalcdfilterrealm, lccd_allrealmstxt)



    local lccd_globalcdfilterprof = CreateFrame("Frame", "lccd_globalcdfilterprof", lccd_globalcdframe, "UIDropDownMenuTemplate")
    lccd_globalcdfilterprof:SetPoint("LEFT", lccd_globalcdfilterrealm, "RIGHT", -25, 0)
    lccd_globalcdfilterprof.initialize = function()
        local dd = {}
        local proftable, _ = lccd_getfiltertable("profession")
        for i, entry in pairs(proftable)
        do
            dd.text = entry["name"]
            dd.value = entry["key"]
            dd.notCheckable = ""
            dd.func = function(self)
                UIDropDownMenu_SetText(lccd_globalcdfilterprof, entry["name"])
                lccd_gdcfilterprof = self.value
                lccd_globalcdlist()
            end
            UIDropDownMenu_AddButton(dd)
        end
        dd.text = lccd_allprofstxt
        dd.value = ""
        dd.notCheckable = ""
        dd.func = function(self)
            UIDropDownMenu_SetText(lccd_globalcdfilterprof, lccd_allprofstxt)
            lccd_gdcfilterprof = ""
            lccd_globalcdlist()
        end
        UIDropDownMenu_AddButton(dd)
    end

    lccd_globalcdfilterprof:SetScript("OnEnter", function(self, motion)
            GameTooltip:SetOwner(lccd_globalcdfilterprof, "ANCHOR_TOPLEFT");
            local ttfilterprof, _ = GetSpellInfo(lccd_gdcfilterprof)
            if lccd_gdcfilterprof == "" then
                ttfilterprof = lccd_allprofstxt
            end
            GameTooltip:SetText(lccd_professiontxt .. ": " .. ttfilterprof);
        end)
    lccd_globalcdfilterprof:SetScript("OnLeave", function(self, motion)
            GameTooltip:Hide()
        end)

    UIDropDownMenu_SetWidth(lccd_globalcdfilterprof, 90)
    UIDropDownMenu_SetText(lccd_globalcdfilterprof, lccd_allprofstxt)

    
    local lccd_globalcdfilterskill = CreateFrame("Frame", "lccd_globalcdfilterskill", lccd_globalcdframe, "UIDropDownMenuTemplate")
    lccd_globalcdfilterskill:SetPoint("LEFT", lccd_globalcdfilterprof, "RIGHT", -25, 0)
    lccd_globalcdfilterskill.initialize = function()
        local dd = {}
        local _, skilltable = lccd_getfiltertable("cooldown")
        for i, entry in pairs(skilltable)
        do
            dd.text = entry
            dd.value = entry
            dd.notCheckable = ""
            dd.func = function(self)
                UIDropDownMenu_SetText(lccd_globalcdfilterskill, entry)
                lccd_gdcfilterskill = self.value
                lccd_globalcdlist()
            end
            UIDropDownMenu_AddButton(dd)
        end
        dd.text = lccd_allskills
        dd.value = ""
        dd.notCheckable = ""
        dd.func = function(self)
            UIDropDownMenu_SetText(lccd_globalcdfilterskill, lccd_allskills)
            lccd_gdcfilterskill = ""
            lccd_globalcdlist()
        end
        UIDropDownMenu_AddButton(dd)
    end

    lccd_globalcdfilterskill:SetScript("OnEnter", function(self, motion)
            GameTooltip:SetOwner(lccd_globalcdfilterskill, "ANCHOR_TOPLEFT");
            local ttfilterskill = lccd_gdcfilterskill
            if lccd_gdcfilterskill == "" then
                ttfilterskill = lccd_allskills
            end
            GameTooltip:SetText(lccd_skilltxt .. ": " .. ttfilterskill);
        end)
    lccd_globalcdfilterskill:SetScript("OnLeave", function(self, motion)
            GameTooltip:Hide()
        end)

    UIDropDownMenu_SetWidth(lccd_globalcdfilterskill, 90)
    UIDropDownMenu_SetText(lccd_globalcdfilterskill, lccd_allskills)


    local lccd_usercdsetbg = CreateFrame("Frame", "Background-User-CD", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_usercdsetbg:SetPoint("TOP", -135, -16); lccd_usercdsetbg:SetWidth(230); lccd_usercdsetbg:SetHeight(84);
    lccd_usercdsetbg:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bgblue",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })

    local lccd_usercdsettitle = lccd_usercdsetbg:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	lccd_usercdsettitle:SetPoint("TOP", 0, -8)
	lccd_usercdsettitle:SetText(lccd_ignoredusercooldownstxt)
    
	local lccd_resetUIgnoredButton = CreateFrame("Button", "resetUIgnoredButtonFrame", lccd_usercdsetbg, "UIPanelButtonTemplate")
	lccd_resetUIgnoredButton:SetPoint("BOTTOM", 0, 8)
	lccd_resetUIgnoredButton:SetScript("OnClick", function()
	        lccd_usercache['userignored'] = {}
            lccd_globalcdlist()
	        print(format("%s%s%s", prefix, "|cffff00ff", "Ignore list for current user cleared!"))
	    end)
	lccd_resetUIgnoredButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_resetUIgnoredButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText(lccd_resetCignoredtooltip, nil, nil, nil, nil, 1);
	    end)
	lccd_resetUIgnoredButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_resetUIgnoredButton:SetText(lccd_resetcignoredtxt)
	lccd_resetUIgnoredButton:SetWidth(200)
    
	local lccd_UIgnoreSelectdButton = CreateFrame("Button", "lccd_UIgnoreSelectdButtonFrame", lccd_usercdsetbg, "UIPanelButtonTemplate")
	lccd_UIgnoreSelectdButton:SetPoint("BOTTOMRIGHT", -10, 34)
	lccd_UIgnoreSelectdButton:SetScript("OnClick", function()
            lccd_Uselecttofilter()
            lccd_globalcdlist()
	    end)
	lccd_UIgnoreSelectdButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_UIgnoreSelectdButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText((lccd_ignoreselectedcooldownstxt .. "\n(" .. lccd_ignoredusercooldownstxt .. ")"), nil, nil, nil, nil, 1);
	    end)
	lccd_UIgnoreSelectdButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_UIgnoreSelectdButton:SetText("+")
	lccd_UIgnoreSelectdButton:SetWidth(90)
    
	local lccd_UIgnoredeSelectdButton = CreateFrame("Button", "lccd_UIgnoredeSelectdButtonFrame", lccd_usercdsetbg, "UIPanelButtonTemplate")
	lccd_UIgnoredeSelectdButton:SetPoint("BOTTOMLEFT", 10, 34)
	lccd_UIgnoredeSelectdButton:SetScript("OnClick", function()
            lccd_Udeselecttofilter()
            lccd_globalcdlist()
	    end)
	lccd_UIgnoredeSelectdButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_UIgnoredeSelectdButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText((lccd_unignoreselectedcooldownstxt .. "\n(" .. lccd_ignoredusercooldownstxt .. ")"), nil, nil, nil, nil, 1);
	    end)
	lccd_UIgnoredeSelectdButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_UIgnoredeSelectdButton:SetText("-")
	lccd_UIgnoredeSelectdButton:SetWidth(90)
 
    local lccd_globalcdsetbg = CreateFrame("Frame", "Background-Global-CD", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdsetbg:SetPoint("TOP", 135, -16); lccd_globalcdsetbg:SetWidth(230); lccd_globalcdsetbg:SetHeight(84);
    lccd_globalcdsetbg:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bgyellow",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })
    
    local lccd_globalcdsettitle = lccd_globalcdsetbg:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	lccd_globalcdsettitle:SetPoint("TOP", 0, -8)
	lccd_globalcdsettitle:SetText(lccd_ignoredglobalcooldownstxt)    

	local lccd_resetGIgnoredButton = CreateFrame("Button", "resetGIgnoredButtonFrame", lccd_globalcdsetbg, "UIPanelButtonTemplate")
	lccd_resetGIgnoredButton:SetPoint("BOTTOM", 0, 8)
	lccd_resetGIgnoredButton:SetScript("OnClick", function()
	        lccd_globalCache['globalIgnored'] = {}
            lccd_globalcdlist()
	        print(format("%s%s%s", prefix, "|cffff00ff", "Global ignore list cleared!"))
	    end)
	lccd_resetGIgnoredButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_resetGIgnoredButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText(lccd_resetGignoredtooltip, nil, nil, nil, nil, 1);
	    end)
	lccd_resetGIgnoredButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_resetGIgnoredButton:SetText(lccd_resetcignoredtxt)
	lccd_resetGIgnoredButton:SetWidth(200)

	local lccd_GIgnoreSelectdButton = CreateFrame("Button", "lccd_GIgnoreSelectdButtonFrame", lccd_globalcdsetbg, "UIPanelButtonTemplate")
	lccd_GIgnoreSelectdButton:SetPoint("BOTTOMRIGHT", -10, 34)
	lccd_GIgnoreSelectdButton:SetScript("OnClick", function()
            lccd_Gselecttofilter()
            lccd_globalcdlist()
	    end)
	lccd_GIgnoreSelectdButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_GIgnoreSelectdButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText((lccd_ignoreselectedcooldownstxt .. "\n(" .. lccd_ignoredglobalcooldownstxt .. ")"), nil, nil, nil, nil, 1);
	    end)
	lccd_GIgnoreSelectdButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_GIgnoreSelectdButton:SetText("+")
	lccd_GIgnoreSelectdButton:SetWidth(90)
    
	local lccd_GIgnoredeSelectdButton = CreateFrame("Button", "lccd_GIgnoredeSelectdButtonFrame", lccd_globalcdsetbg, "UIPanelButtonTemplate")
	lccd_GIgnoredeSelectdButton:SetPoint("BOTTOMLEFT", 10, 34)
	lccd_GIgnoredeSelectdButton:SetScript("OnClick", function()
            lccd_Gdeselecttofilter()
            lccd_globalcdlist()
	    end)
	lccd_GIgnoredeSelectdButton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lccd_GIgnoredeSelectdButton, "ANCHOR_TOPLEFT");
        	GameTooltip:SetText((lccd_unignoreselectedcooldownstxt .. "\n(" .. lccd_ignoredglobalcooldownstxt .. ")"), nil, nil, nil, nil, 1);
	    end)
	lccd_GIgnoredeSelectdButton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
	lccd_GIgnoredeSelectdButton:SetText("-")
	lccd_GIgnoredeSelectdButton:SetWidth(90)


function lccd_Uselecttofilter()

    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
            if (lccd_gdcfilterrealm == "") or (entry['realm'] == lccd_gdcfilterrealm) then
                if (lccd_gdcfilterprof == "") or (entry['profession'] == lccd_gdcfilterprof) then
                    if (lccd_gdcfilterskill == "") or (entry['cooldown'] == lccd_gdcfilterskill) then
                        lccd_usercache['userignored'][entry['name']] = true
                    end
                end
            end
        end
    end


--    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
--        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
--            lccd_usercache['userignored'][entry['name']] = true
--        end
--    end
end

function lccd_Udeselecttofilter()

    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
            if (lccd_gdcfilterrealm == "") or (entry['realm'] == lccd_gdcfilterrealm) then
                if (lccd_gdcfilterprof == "") or (entry['profession'] == lccd_gdcfilterprof) then
                    if (lccd_gdcfilterskill == "") or (entry['cooldown'] == lccd_gdcfilterskill) then
                        lccd_usercache['userignored'][entry['name']] = nil
                    end
                end
            end
        end
    end

--    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
--        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
--            lccd_usercache['userignored'][entry['name']] = nil
--        end
--    end
end

function lccd_Gselecttofilter()

    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
            if (lccd_gdcfilterrealm == "") or (entry['realm'] == lccd_gdcfilterrealm) then
                if (lccd_gdcfilterprof == "") or (entry['profession'] == lccd_gdcfilterprof) then
                    if (lccd_gdcfilterskill == "") or (entry['cooldown'] == lccd_gdcfilterskill) then
                        lccd_globalCache['globalIgnored'][entry['name']] = true
                    end
                end
            end
        end
    end

--    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
--        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
--            lccd_globalCache['globalIgnored'][entry['name']] = true
--        end
--    end
end

function lccd_Gdeselecttofilter()

    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
            if (lccd_gdcfilterrealm == "") or (entry['realm'] == lccd_gdcfilterrealm) then
                if (lccd_gdcfilterprof == "") or (entry['profession'] == lccd_gdcfilterprof) then
                    if (lccd_gdcfilterskill == "") or (entry['cooldown'] == lccd_gdcfilterskill) then
                        lccd_globalCache['globalIgnored'][entry['name']] = nil
                    end
                end
            end
        end
    end

--    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
--        if (string.find(string.lower(entry['name']), string.lower(lccd_gdcfilter))) then
--            lccd_globalCache['globalIgnored'][entry['name']] = nil
--        end
--    end
end


    local lccd_globalcdscrollframebg = CreateFrame("Frame", "lccd_globalcdscrollframebg", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollframebg:SetPoint("TOPLEFT", 104, -127); lccd_globalcdscrollframebg:SetWidth(453); lccd_globalcdscrollframebg:SetHeight(374);
    lccd_globalcdscrollframebg:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bggrey",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })

    local lccd_globalcdscrollframebg1 = CreateFrame("Frame", "lccd_globalcdscrollframebg1", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollframebg1:SetPoint("RIGHT", lccd_globalcdscrollframebg,"LEFT", 2, 0); lccd_globalcdscrollframebg1:SetWidth(28); lccd_globalcdscrollframebg1:SetHeight(374);
    lccd_globalcdscrollframebg1:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bgyellow",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })
    
    local lccd_globalcdscrollframebg2 = CreateFrame("Frame", "lccd_globalcdscrollframebg2", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollframebg2:SetPoint("RIGHT", lccd_globalcdscrollframebg1,"LEFT", 1, 0); lccd_globalcdscrollframebg2:SetWidth(28); lccd_globalcdscrollframebg2:SetHeight(374);
    lccd_globalcdscrollframebg2:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bgblue",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })

    local lccd_globalcdscrollframebg3 = CreateFrame("Frame", "lccd_globalcdscrollframebg3", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollframebg3:SetPoint("RIGHT", lccd_globalcdscrollframebg2,"LEFT", 1, 0); lccd_globalcdscrollframebg3:SetWidth(28); lccd_globalcdscrollframebg3:SetHeight(374);
    lccd_globalcdscrollframebg3:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bgred",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })

    local lccd_globalcdscrollbarbg = CreateFrame("Frame", "lccd_globalcdscrollbarbg", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollbarbg:SetPoint("LEFT", lccd_globalcdscrollframebg, "RIGHT", 1, 0); lccd_globalcdscrollbarbg:SetWidth(26); lccd_globalcdscrollbarbg:SetHeight(374);
    lccd_globalcdscrollbarbg:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bglight",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 16,
        insets = {
            left = 2,
            right = 2,
            top = 2,
            bottom = 2,
        },
    })

    local lccd_globalcdscrollbarbg1 = CreateFrame("Frame", "lccd_globalcdscrollbarbg1", lccd_globalcdframe, BackdropTemplateMixin and "BackdropTemplate")
    lccd_globalcdscrollbarbg1:SetPoint("LEFT", lccd_globalcdscrollframebg, "RIGHT", 4, 0); lccd_globalcdscrollbarbg1:SetWidth(19); lccd_globalcdscrollbarbg1:SetHeight(329);
    lccd_globalcdscrollbarbg1:SetBackdrop({
        bgFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/bggrey",
        tile = true,
        edgeFile = "Interface/AddOns/Lemmos_CraftCooldown/Artwork/Border",
        edgeSize = 8,
        insets = {
            left = 1,
            right = 1,
            top = 1,
            bottom = 1,
        },
    })

    local lccd_globalcdscrollframe = CreateFrame("ScrollFrame", nil, lccd_globalcdframe, "UIPanelScrollFrameTemplate")
    lccd_globalcdscrollframe:SetPoint("TOPLEFT", 22, -132)
    lccd_globalcdscrollframe:SetSize(535, 364)
    lccd_globalcdscrollframe:Show()

    lccd_globalcdscrollframechild:SetParent(lccd_globalcdscrollframe)
    lccd_globalcdscrollframechild:SetSize(535, 364)

    lccd_globalcdscrollframe:SetScrollChild(lccd_globalcdscrollframechild)
    lccd_globalcdscrollframechild:Show()

    lccd_globalcdlist()
    
    lccd_ignoredopts:SetScript("OnShow", function()
        lccd_globalcdfilter:SetText(lccd_gdcfilter)
        lccd_globalcdlist()
    end)
end)

InterfaceOptions_AddCategory(lccd_options.owncd)

lccd_MainFrame:RegisterEvent("ADDON_LOADED")
lccd_MainFrame:RegisterEvent("TRADE_SKILL_SHOW")
lccd_MainFrame:RegisterEvent("TRADE_SKILL_UPDATE")

if (lccd_wowv == 2 or lccd_wowv == 3) then
    lccd_MainFrame:RegisterEvent("CRAFT_SHOW")
    lccd_MainFrame:RegisterEvent("CRAFT_UPDATE")
end

lccd_MainFrame:RegisterEvent("PLAYER_LOGIN")
lccd_MainFrame:RegisterEvent("BAG_UPDATE_COOLDOWN")
lccd_MainFrame:RegisterEvent("BAG_UPDATE")
lccd_MainFrame:RegisterEvent("BAG_OPEN")
lccd_MainFrame:RegisterEvent("ITEM_TEXT_BEGIN")
lccd_MainFrame:RegisterEvent("UNIT_INVENTORY_CHANGED")

function lccd_MainFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Lemmos_CraftCooldown"
	then
		lccd_init()
	elseif event == 'BAG_UPDATE' or event == 'BAG_UPDATE_COOLDOWN' or event == 'BAG_OPEN'
	then
	    if lccd_usercache['config']['saltshakescan']
	    then
            if lccd_hasLeatherworking and lccd_wowv < 3 then
                lccd_refreshItems()
            end
        end
	elseif event == 'TRADE_SKILL_SHOW'
	then
		flag = true
	elseif event == "TRADE_SKILL_UPDATE"
	then
		if flag
		then
			lccd_printSkills()
			flag = false
		else
			lccd_refreshSkills()
		end
	elseif event == 'CRAFT_SHOW' and (lccd_wowv == 2 or lccd_wowv == 3)
	then
		flag1 = true
	elseif event == "CRAFT_UPDATE" and (lccd_wowv == 2 or lccd_wowv == 3)
	then
		if flag1
		then
			lccd_printCrafts()
			flag1 = false
		else
			lccd_refreshCrafts()
		end
	end
end
lccd_MainFrame:SetScript("OnEvent", lccd_MainFrame.OnEvent);

local frame = CreateFrame("FRAME")
frame.name = addonName .. 'Main'
frame:SetScript("OnUpdate", function(self, elapsed)
	CraftCooldown_OnUpdate(self, elapsed)
end);

SLASH_CRAFTCOOLDOWN1 = '/ccd'
function SlashCmdList.CRAFTCOOLDOWN(msg)
	if msg ~= nil and msg ~= ""
	then 
		if msg == 'demo'
		then
			lccd_soundplay()
			lccd_demo()
		elseif msg == 'p'
		then
			lccd_printCached()
		elseif msg == 'help'
		then
		    print(format("%s%s", prefix, "   " .. addonName .. " -- v." .. addonVersion))
			print(format("%s%s", prefix, lccd_helptext1))
			print(format("%s%s", prefix, lccd_helptext2))
			print(format("%s%s", prefix, lccd_helptext3))
			print(format("%s%s", prefix, lccd_helptext4))
		end
	else
		InterfaceOptionsFrame_OpenToCategory(addonName)
		InterfaceOptionsFrame_OpenToCategory(addonName)
	end
end

function CraftCooldown_OnUpdate(self, elapsed)
	delay = elapsed + delay
	if(delay > 5)
	then
		delay = 0
        CraftCooldown_update()
        if lccd_usercache['config']['DisplayIcon']
        then
            ssdisp.texture:SetAlpha(alphassdisp);
        end
	end
end

function CraftCooldown_update()
    lccd_printwidget()
    local readyAt = nil
    local lccd_upd_ItemLink = nil
    local lccd_IL_SSh = false
    local lccd_IL_Arc = false
    local lccd_IL_MC = false
    local lccd_IL_BG = false
    local lccd_IL_SSh_p = false
    local lccd_IL_Arc_p = false
    local lccd_IL_MC_p = false
    local lccd_IL_BG_p = false
    local lccd_IL_VS = false
    local lccd_IL_VS_p = false
    local lccd_IL_IF = false
    local lccd_IL_IF_p = false

    ssdisp3ap.texture:SetTexture(nil)
	if lccd_usercache['config']['onReady']
	then
		cdtriggered = false
		ownprof = false
		for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true)))
		do
            skillName = entry['name']
			readyAt = entry['seconds']
			lccd_upd_ItemLink = entry['seconds']['scitemid']
			seconds = readyAt['timer'] - time()
			if (( seconds < 0 and seconds > -6 ) or (seconds < 0 and ((not UnitAffectingCombat("player")) and lccd_playerwasincombat)))
			then
				lccd_CDReady(skillName, lccd_upd_ItemLink)
			end
		    
		    if seconds < 0
		        then
                    if (entry['realm'] == GetRealmName("player")) and (entry['char'] == UnitName("player")) and (not ((lccd_isGlobalCooldownIgnored(skillName)) or lccd_isUserCooldownIgnored(skillName)))
	                    then
                        if lccd_usercache['IconResize'] then
                            if lccd_arraycontainsvalue(lccd_sslist, lccd_upd_ItemLink) then
                                lccd_IL_SSh_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_alchemylist, lccd_upd_ItemLink) then
                                lccd_IL_Arc_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_tailoringlist, lccd_upd_ItemLink) then
                                lccd_IL_MC_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_jewelcraftinglist, lccd_upd_ItemLink) then
                                lccd_IL_BG_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_jewelcraftinglist, lccd_upd_ItemLink) then
                                lccd_IL_BG_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_enchantinglist, lccd_upd_ItemLink) then
                                lccd_IL_VS_p = true
                            end

                            if lccd_arraycontainsvalue(lccd_inscriptionlist, lccd_upd_ItemLink) then
                                lccd_IL_IF_p = true
                            end
                        end
	                    ownprof = true
                    end
		        cdtriggered = true
                if not ((lccd_isGlobalCooldownIgnored(skillName)) or lccd_isUserCooldownIgnored(skillName)) then
                    if lccd_arraycontainsvalue(lccd_sslist, lccd_upd_ItemLink) then
                        lccd_IL_SSh = true
                    end

                    if lccd_arraycontainsvalue(lccd_alchemylist, lccd_upd_ItemLink) then
                        lccd_IL_Arc = true
                    end

                    if lccd_arraycontainsvalue(lccd_tailoringlist, lccd_upd_ItemLink) then
                        lccd_IL_MC = true
                    end

                    if lccd_arraycontainsvalue(lccd_jewelcraftinglist, lccd_upd_ItemLink) then
                        lccd_IL_BG = true
                    end

                    if lccd_arraycontainsvalue(lccd_jewelcraftinglist, lccd_upd_ItemLink) then
                        lccd_IL_BG = true
                    end

                    if lccd_arraycontainsvalue(lccd_enchantinglist, lccd_upd_ItemLink) then
                        lccd_IL_VS = true
                    end

                    if lccd_arraycontainsvalue(lccd_inscriptionlist, lccd_upd_ItemLink) then
                        lccd_IL_IF = true
                    end
	            end
	        end
		end
		if cdtriggered
		then
		    if ownprof
		    then
		        alphassdisp = 1
	        else
	            alphassdisp = 0.5
            end
		else
		    alphassdisp = 0.2
	    end
	end
	if lccd_IL_SSh
	    then
	    if lccd_IL_SSh_p then
	        ssdisp3ap.texture:SetTexture("133848")
	        ssdisp1.texture:SetTexture(nil)
        else
    	    ssdisp1.texture:SetTexture("133848")
	    end
    else
        ssdisp1.texture:SetTexture(nil)
    end
	if lccd_IL_MC
	    then
	    if lccd_IL_MC_p then
	        ssdisp3ap.texture:SetTexture("132895")
	        ssdisp2.texture:SetTexture(nil)
        else
    	    ssdisp2.texture:SetTexture("132895")
	    end
    else
        ssdisp2.texture:SetTexture(nil)
    end
	if lccd_IL_Arc
	    then
	    if lccd_IL_Arc_p then
	        ssdisp3ap.texture:SetTexture("134459")
	        ssdisp3.texture:SetTexture(nil)
        else
	        ssdisp3.texture:SetTexture("134459")
	    end
    else
        ssdisp3.texture:SetTexture(nil)
    end
	if lccd_IL_BG
	    then
	    if lccd_IL_BG_p then
	        ssdisp3ap.texture:SetTexture("134096")
	        ssdisp4.texture:SetTexture(nil)
        else
    	    ssdisp4.texture:SetTexture("134096")
	    end
    else
        ssdisp4.texture:SetTexture(nil)
    end
	if lccd_IL_VS
	    then
	    if lccd_IL_VS_p then
	        ssdisp3ap.texture:SetTexture("132886")
	        ssdisp5.texture:SetTexture(nil)
        else
    	    ssdisp5.texture:SetTexture("132886")
	    end
    else
        ssdisp5.texture:SetTexture(nil)
    end
	if lccd_IL_IF
	    then
	    if lccd_IL_IF_p then
	        ssdisp3ap.texture:SetTexture("237171")
	        ssdisp6.texture:SetTexture(nil)
        else
    	    ssdisp6.texture:SetTexture("237171")
	    end
    else
        ssdisp6.texture:SetTexture(nil)
    end
end

function lccd_soundplay()
	PlaySound(6290)
end

function lccd_CDReady(skilltoprint, ItemLinktoprint)
    if UnitAffectingCombat("player") then
        lccd_playerwasincombat = true
        lccd_cooldownstriggered[skilltoprint] = ItemLinktoprint
    else
        if lccd_playerwasincombat then
            for skillcbname, cbitemlink in pairs(lccd_cooldownstriggered) do
                lccd_printSkill(skillcbname, -1, cbitemlink, true, nil, false)
            end
            lccd_playerwasincombat = false
            lccd_cooldownstriggered = {}
        else
            lccd_printSkill(skilltoprint, -1, ItemLinktoprint, true, nil, false)
        end
        if not lccd_widget:IsVisible() then
            lccd_widget:Show()
            lccd_widgetButton:SetHeight(lccd_widget:GetHeight())
        end
        lccd_soundplay()
    end
end

function lccd_init()
    C_Timer.After(20, function()
        local i = 1
        while true do
            local spellName, spellSubName, spellID = GetSpellBookItemName(i, BOOKTYPE_SPELL)
            if not spellName then
                do break end
            end
            if (spellID == 10662) or (spellID == 32549) then
                lccd_hasLeatherworking = true
            end
            i = i + 1
        end
    end)


	if lccd_usercache == nil
	then
		lccd_usercache = {
            ['userignored'] = {},
			config = {
				['onLogin'] = true,
				['onOpen'] = true,
				['onReady'] = true,
				['DisplayIcon'] = true,
			},
			version = '0'
		}
	end
    
	if lccd_usercache['userignored'] == nil
	then
		lccd_usercache['userignored'] = {}
	end    
	if lccd_usercache['config'] == nil
	then
		lccd_usercache['config'] = {}
	end
	if lccd_usercache['config']['onReady'] == nil
	then
		lccd_usercache['config']['onReady'] = true
	end
	if lccd_usercache['config']['saltshakescan'] == nil
	then
		lccd_usercache['config']['saltshakescan'] = true
	end
	if lccd_usercache['config']['DisplayIcon'] == nil
	then
		lccd_usercache['config']['DisplayIcon'] = true
	end

	if lccd_usercache['fIconMove'] == nil
	then
		lccd_usercache['fIconMove'] = false
	end

	if lccd_usercache['WidgetnotVisible'] == nil
	then
		lccd_usercache['WidgetnotVisible'] = false
	end

    if lccd_usercache['WidgetnotVisible'] then
        lccd_widget:Hide()
        lccd_widgetButton:SetHeight(20)
        lccd_widgetButton:SetNormalTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfnopen.tga")
        lccd_widgetButton:SetPushedTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopen.tga")
        lccd_widgetButton:SetHighlightTexture("Interface/AddOns/Lemmos_CraftCooldown/Artwork/cfopen.tga")
    end

	if lccd_usercache['IconResize'] == nil
	then
		lccd_usercache['IconResize'] = true
	end
	
	if lccd_usercache['IconPosrel'] == nil
	then
		lccd_usercache['IconPosrel'] = "TOPLEFT"
	end

	if lccd_usercache['IconPosx'] == nil
	then
		lccd_usercache['IconPosx'] = 0
	end

	if lccd_usercache['IconPosy'] == nil
	then
		lccd_usercache['IconPosy'] = 0
	end

-- widget

	if lccd_usercache['WidgetShow'] == nil
	then
		lccd_usercache['WidgetShow'] = true
	end

	if lccd_usercache['WidgetSize'] == nil
	then
		lccd_usercache['WidgetSize'] = 1
	end

	if lccd_usercache['fWidgetMove'] == nil
	then
		lccd_usercache['fWidgetMove'] = false
	end

	if lccd_usercache['WidgetPosrel'] == nil
	then
		lccd_usercache['WidgetPosrel'] = "LEFT"
	end

	if lccd_usercache['WidgetPosx'] == nil
	then
		lccd_usercache['WidgetPosx'] = 0
	end

	if lccd_usercache['WidgetPosy'] == nil
	then
		lccd_usercache['WidgetPosy'] = 0
	end

    lccd_widgetButton:SetPoint(lccd_usercache['WidgetPosrel'], lccd_usercache['WidgetPosx'], lccd_usercache['WidgetPosy'])
    
    if lccd_usercache['fWidgetMove'] then
        lccd_movewidget(true)
    else
        lccd_movewidget(false)
    end

    lccd_widgetButton:SetScale(lccd_usercache['WidgetSize'])
    
    if lccd_usercache['WidgetShow'] then
        lccd_widgetButton:Show()
    else
        lccd_widgetButton:Hide()
    end
    
--widget end

	local name = UnitName("player")
	local realm = GetRealmName("player")
	if lccd_globalCache == nil
	then
		print('Init global')
		lccd_globalCache = {
			crafts1 = {}
		}
	end
	if lccd_globalCache['crafts1'] == nil
	then
		print('Init global realm')
		lccd_globalCache['crafts1'] = {}
	end
	if lccd_globalCache['crafts1'][realm] == nil
	then
		print('Init global realm')
		lccd_globalCache['crafts1'][realm] = {}
	end
	if lccd_globalCache['crafts1'][realm][name] == nil
	then
		print('Init global realm char')
		lccd_globalCache['crafts1'][realm][name] = {}
	end

	if lccd_globalCache['tDisplayIcon'] == nil
	then
		lccd_globalCache['tDisplayIcon'] = false
	end

	if lccd_globalCache['IconDoubleSize'] == nil
	then
		lccd_globalCache['IconDoubleSize'] = false
	end

    if lccd_globalCache['IconDoubleSize']
    then
        ssdisp:SetWidth(24)
        ssdisp:SetHeight(24)

        ssdisp1:SetWidth(14)
        ssdisp1:SetHeight(14)

        ssdisp2:SetWidth(14)
        ssdisp2:SetHeight(14)

        ssdisp3:SetWidth(14)
        ssdisp3:SetHeight(14)

        ssdisp4:SetPoint("TOPRIGHT", ssdisp, "TOPRIGHT", 5, 5)
        ssdisp4:SetWidth(14)
        ssdisp4:SetHeight(14)

        ssdisp5:SetWidth(14)
        ssdisp5:SetHeight(14)

        ssdisp6:SetWidth(14)
        ssdisp6:SetHeight(14)

        ssdisp3ap:SetWidth(24)
        ssdisp3ap:SetHeight(24)
        if (lccd_wowv == 2 or lccd_wowv == 3) then
            ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -5, 5)
            ssdisp2:SetPoint("BOTTOMRIGHT", ssdisp, "BOTTOMRIGHT", 5, -5)
            ssdisp3:SetPoint("BOTTOMLEFT", ssdisp, "BOTTOMLEFT", -5, -5)
            ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, -5)
        else
            ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
            ssdisp2:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", 15, 3)
            ssdisp3:SetPoint("CENTER", ssdisp, "CENTER", 0, -7)
        end
    else
        ssdisp:SetWidth(16)
        ssdisp:SetHeight(16)

        ssdisp1:SetWidth(9)
        ssdisp1:SetHeight(9)

        ssdisp2:SetWidth(9)
        ssdisp2:SetHeight(9)

        ssdisp3:SetWidth(9)
        ssdisp3:SetHeight(9)

        ssdisp4:SetPoint("TOPRIGHT", ssdisp, "TOPRIGHT", 3, 3)
        ssdisp4:SetWidth(9)
        ssdisp4:SetHeight(9)

        ssdisp5:SetWidth(9)
        ssdisp5:SetHeight(9)

        ssdisp6:SetWidth(9)
        ssdisp6:SetHeight(9)

        ssdisp3ap:SetWidth(16)
        ssdisp3ap:SetHeight(16)
        if (lccd_wowv == 2 or lccd_wowv == 3) then
            ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -3, 3)
            ssdisp2:SetPoint("BOTTOMRIGHT", ssdisp, "BOTTOMRIGHT", 3, -3)
            ssdisp3:SetPoint("BOTTOMLEFT", ssdisp, "BOTTOMLEFT", -3, -3)
            ssdisp3ap:SetPoint("TOP", ssdisp, "BOTTOM", 0, -3)
        else
            ssdisp1:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", -2, 2)
            ssdisp2:SetPoint("TOPLEFT", ssdisp, "TOPLEFT", 10, 2)
            ssdisp3:SetPoint("CENTER", ssdisp, "CENTER", 0, -5)
        end
    end

	if lccd_globalCache['globalIgnored'] == nil
	then
		lccd_globalCache['globalIgnored'] = {}
	end

	if lccd_usercache['config']['onLogin']
	then
	    C_Timer.After(20, function() lccd_printCached() end)
	end
    if lccd_usercache['config']['DisplayIcon']
    then
        ssdisp:Show()
    else
        ssdisp:Hide()
    end
   
    if lccd_usercache['fIconMove']
    then
        lccd_moveicon(true)
        ssdisp:SetPoint(lccd_usercache['IconPosrel'], lccd_usercache['IconPosx'], lccd_usercache['IconPosy'])
    else
        lccd_moveicon(false)
        if (lccd_wowv == 2 or lccd_wowv == 3) then
            if lccd_globalCache['tDisplayIcon']
            then
                ssdisp:SetPoint("TOPLEFT", 5, -66)
            else
                ssdisp:SetPoint("TOPLEFT", 5, -5)
            end
        else
            if lccd_globalCache['tDisplayIcon']
            then
                ssdisp:SetPoint("TOPLEFT", 2, -66)
            else
                ssdisp:SetPoint("TOPLEFT", 2, -2)
            end
        end
    end
end

function lccd_toggleIgnoreGlobalCooldown(cooldown)
	if lccd_isGlobalCooldownIgnored(cooldown)
	then
		lccd_unIgnoreGlobalCooldown(cooldown)
	else
		lccd_ignoreGlobalCooldown(cooldown)
	end
end

function lccd_toggleIgnoreUserCooldown(cooldown)
	if lccd_isUserCooldownIgnored(cooldown)
	then
		lccd_unIgnoreUserCooldown(cooldown)
	else
		lccd_ignoreUserCooldown(cooldown)
	end
end

function lccd_ignoreGlobalCooldown(cooldown)
	lccd_globalCache['globalIgnored'][cooldown] = true
end

function lccd_unIgnoreGlobalCooldown(cooldown)
	lccd_globalCache['globalIgnored'][cooldown] = nil
end

function lccd_ignoreUserCooldown(cooldown)
	lccd_usercache['userignored'][cooldown] = true
end

function lccd_unIgnoreUserCooldown(cooldown)
	lccd_usercache['userignored'][cooldown] = nil
end

function lccd_isGlobalCooldownIgnored(cooldown)
	if lccd_globalCache['globalIgnored'][cooldown] == nil
	then
		return false
	else
		return lccd_globalCache['globalIgnored'][cooldown]
	end
end

function lccd_isUserCooldownIgnored(cooldown)
	if lccd_usercache['userignored'][cooldown] == nil
	then
		return false
	else
		return lccd_usercache['userignored'][cooldown]
	end
end

function lccd_refreshSkills()
    local skillname, skilllevel, skillmaxlevel = GetTradeSkillLine()
    local skills = {}
    local lccd_tsidout= nil
   	for i=1,#lccd_TradeSkillList,1 do
		local lccd_tsid = lccd_TradeSkillList[i]
		local lccd_tempidname = GetSpellInfo(lccd_tsid)
		if lccd_tempidname == skillname then
		    lccd_tsidout = lccd_tsid
	    end
	end
    
    local itisprofession = (lccd_tsidout == 2259) or (lccd_tsidout == 3908)
    
    if (lccd_wowv == 2) then
        itisprofession = (lccd_tsidout == 2259) or (lccd_tsidout == 3908) or (lccd_tsidout == 25229)
    end
    
    if (lccd_wowv == 3) then
        itisprofession = (lccd_tsidout == 2259) or (lccd_tsidout == 3908) or (lccd_tsidout == 25229) or (lccd_tsidout == 45357)
    end
--print(skillname)    
    if itisprofession
        then
	    for a=0, GetNumTradeSkills(), 1
	    do
		    skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(a);
	        local skilleditemlink = nil
	        local skilleditemid = "N.A"
            skilleditemlink = GetTradeSkillItemLink(a)
            if skilleditemlink ~= nil
                then
                local lccd_sif, _, _, _, _, _, _ = GetSpellInfo(61288)
                local lccd_ifn, _, _, _, _, _, _ = GetSpellInfo(61177)
                if skillName == lccd_sif then
                    skilleditemid = 61288
                elseif skillName == lccd_ifn then
                    skilleditemid = 61177
                else
                    skilleditemid = GetItemInfoInstant(skilleditemlink)
                end
		    end
		    seconds,y = GetTradeSkillCooldown(a);
		    if seconds and seconds > 10
		    then
			    lccd_cacheCooldown(skillName, time() + seconds, skilleditemid, lccd_tsidout)
			    if lccd_usercache['config']['onOpen']
			    then
				    table.insert(skills, {skillName, seconds, skilleditemid})
			    end
		    end
        end
    end
    if lccd_tsidout == 2108
        then

        local i = 1
        while true do
            local spellName, spellSubName, spellID = GetSpellBookItemName(i, BOOKTYPE_SPELL)
            if not spellName then
                do break end
            end
            if (spellID == 10662) or (spellID == 32549) then
                lccd_hasLeatherworking = true
            end
            i = i + 1
        end

        for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true)))
        do
            local skillName = entry['name']
            local seconds = entry['seconds']['timer']
            local lccd_PC_ItemLink = entry['seconds']['scitemid']
            local readyAt = seconds - time()
            if ((entry['realm'] == GetRealmName("player")) and (entry['char'] == UnitName("player"))) --and (lccd_PC_ItemLink == 15846)
            then
                if lccd_usercache['config']['onOpen']
                    then
                    table.insert(skills, {entry['cooldown'], readyAt, 15846})
                end
            end
        end
    end
    return skills
end

function lccd_refreshCrafts()
    local cskillname, cskilllevel, cskillmaxlevel = GetCraftDisplaySkillLine()
    local cskills = {}
    local lccd_ctsidout= nil
   	for i=1,#lccd_CraftList,1 do
		local lccd_ctsid = lccd_CraftList[i]
		local lccd_ctempidname = GetSpellInfo(lccd_ctsid)
		if lccd_ctempidname == cskillname then
		    lccd_ctsidout = lccd_ctsid
	    end
	end
--print(cskillname)
    if lccd_ctsidout == 7411
        then
	    for a=0, GetNumCrafts(), 1
	    do
		    lccd_CraftName, _, _, _, _, _ = GetCraftInfo(a);
	        local cskilleditemlink = nil
	        local cskilleditemid = "N.A"
            cskilleditemlink = GetCraftItemLink(a)
            if cskilleditemlink ~= nil
                then
                _, _, _, _, _, _, cskilleditemid = GetSpellInfo(lccd_CraftName)
		    end
		    startTimeVS, durationVS, _, _ = GetSpellCooldown(cskilleditemid);
		    if durationVS and durationVS > 10
		    then
                if startTimeVS < GetTime()
                    then
                        readyAtVS = time() + startTimeVS + durationVS - GetTime()
                else
                    readyAtVS = time() - GetTime() - ((2^32)/1000) + startTimeVS + durationVS
                end
                local readyAtVSo = readyAtVS
                seconds = readyAtVSo - time()

			    lccd_cacheCooldown(lccd_CraftName, readyAtVSo, cskilleditemid, lccd_ctsidout)
			    if lccd_usercache['config']['onOpen']
			    then
				    table.insert(cskills, {lccd_CraftName, seconds, cskilleditemid})
			    end
		    end
        end
    end
    return cskills
end

function lccd_refreshItems()
    local lccd_localizedssname = GetItemInfo(15846)
	for bag = 0, 4
	do
		for slot = 1, GetContainerNumSlots(bag)
		do
			local item = GetContainerItemLink(bag, slot);
			if item ~= nil and lccd_localizedssname ~= nil
			then
				local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(item);
				if sName == lccd_localizedssname
				then
					local startTime, duration, isEnabled = GetContainerItemCooldown(bag, slot);
					if startTime < GetTime()
					    then
					        readyAtss = time() + startTime + duration - GetTime()
			        else
			            readyAtss = time() - GetTime() - ((2^32)/1000) + startTime + duration
		            end
		            local readyAt = readyAtss
					if lccd_globalCache['crafts1'][GetRealmName("player")][UnitName("player")][15846] == nil
					then
						print(format("%s " .. lccd_addedtxt .. " [%s]", prefix, sName))
					end
					lccd_cacheCooldown(sName, readyAt, 15846, 2108)
				end	
			end
		end
	end
end

function lccd_getGlobalCooldowns(includeCurrentCharacter)
	local cName = UnitName("player")
	local cRealm = GetRealmName("player")
	local data = {}
	for realm, realms in pairs(lccd_globalCache['crafts1'])
	do
		for char, chars in pairs(realms)
		do
			for skillentry, seconds in pairs(chars)
			do
				if not (cName == char and cRealm == realm and not includeCurrentCharacter)
				then
                    if seconds['profession'] == nil
                        then
                        local profidadd = 0
                        if seconds["scitemid"] == 15846
                            then
                            profidadd = 2108
                        end
                        if seconds["scitemid"] == 3577 or seconds["scitemid"] == 6037 or seconds["scitemid"] == 7076 or seconds["scitemid"] == 7078 or seconds["scitemid"] == 7080 or seconds["scitemid"] == 7082 or seconds["scitemid"] == 12360 or seconds["scitemid"] == 12803 or seconds["scitemid"] == 12808 or seconds["scitemid"] == 21884 or seconds["scitemid"] == 21885 or seconds["scitemid"] == 21886 or seconds["scitemid"] == 22451 or seconds["scitemid"] == 22452 or seconds["scitemid"] == 22456 or seconds["scitemid"] == 22457 or seconds["scitemid"] == 23571 or seconds["scitemid"] == 25867 or seconds["scitemid"] == 25868 or seconds["scitemid"] == 12360
                            then
                            profidadd = 2259
                        end
                        if seconds["scitemid"] == 24272 or seconds["scitemid"] == 21845 or seconds["scitemid"] == 24271 or seconds["scitemid"] == 14342
                            then
                            profidadd = 3908
                        end
                        if seconds["scitemid"] == 35945
                            then
                            profidadd = 25229
                        end
                        if seconds["scitemid"] == 28028 or seconds["scitemid"] == 28027
                            then
                            profidadd = 7411
                        end
                        seconds['profession'] = profidadd
                    end
                    if seconds['realm'] == nil then
                        seconds['realm'] = realm
                    end
                    if seconds['char'] == nil then
                        seconds['char'] = char
                    end
                    local cooldown = ""
                    if (seconds['cooldown'] == nil) or (skillentry ~= seconds["scitemid"]) then
                        if skillentry ~= seconds["scitemid"] then
                            seconds['cooldown'] = skillentry
                            lccd_globalCache['crafts1'][realm][char][seconds["scitemid"]]={
                                ['timer'] = seconds['timer'],
                                ['scitemid'] = seconds["scitemid"],
                                ['char'] = char,
                                ['realm'] = realm,
                                ['cooldown'] = seconds['cooldown'],
                                ['profession'] = seconds['profession'],
                                ['name'] = format("(%s-%s) %s", char, realm, seconds['cooldown']),
                                }
                            lccd_globalCache['crafts1'][realm][char][skillentry] = nil
                        else
                            local cditemID = seconds["scitemid"]
                            if cditemID == 28028
                                then
                                cditemID = 22459
                            end
                            if cditemID == 28027
                                then
                                cditemID = 22460
                            end
                            local cooldown, _ = GetItemInfo(cditemID)
                            if cooldown then
                                seconds['cooldown'] = cooldown
                            end
                        end
                    else
                        cooldown = seconds['cooldown']
                    end
                    if seconds['name'] == nil then
                        seconds['name'] = format("(%s-%s) %s", char, realm, cooldown)
                    end
                    data[ format("(%s-%s) %s", char, realm, cooldown) ] = seconds
				end
			end
		end
	end
	return data
end

function lccd_cacheCooldown(cooldown, readyAt, citemid, profid)
	local name = UnitName("player")
	local realm = GetRealmName("player")
	lccd_globalCache['crafts1'][realm][name][citemid] = {
	    ['timer'] = readyAt,
	    ['scitemid'] = citemid,
        ['char'] = name,
        ['realm'] = realm,
        ['cooldown'] = cooldown,
        ['profession'] = profid,
        ['name'] = format("(%s-%s) %s", name, realm, cooldown),
	    }
end

function lccd_clearCharacterCache()
	local name = UnitName("player")
	local realm = GetRealmName("player")
	lccd_globalCache['crafts1'][realm][name] = {}
	print(format("%s%s%s", prefix, "|cffff00ff", "Character cache cleared!"))
end

function lccd_clearIgnoredLists()
	lccd_globalCache['globalIgnored'] = {}
	print(format("%s%s%s", prefix, "|cffff00ff", "Ignore lists cleared!"))
end

function lccd_printSkills()
    mmessage = ""
    mmessagett = ""
	for _, row in pairs(lccd_refreshSkills())
	do
        lccd_printSkill(row[1], row[2], row[3], nil, nil, false)
	end
end

function lccd_printCrafts()
    mmessage = ""
    mmessagett = ""
    for _, row1 in pairs(lccd_refreshCrafts())
    do
        lccd_printSkill(row1[1], row1[2], row1[3], nil, nil, false)
    end
end

function lccd_printSkill(skillName, seconds, cditemlink, noTime, gname, istooltip)
    local gradient = lccd_getGradient(seconds)
	local timeStr = format("|r|cff1784d1[|r|cff93B6DB%s%s|r|cff1784d1]|r", "", lccd_disp_time(seconds))
	if noTime 
	then
		timeStr = ""
	end
	local texture = ""
	if cditemlink == nil
	    then
	    texture = ""
    else
        if GetItemIcon(cditemlink) ~= nil
            then
            if cditemlink == 28028
                then
                cditemlink = 22459
            end
            if cditemlink == 28027
                then
                cditemlink = 22460
            end
            
            if cditemlink == 61288 or cditemlink == 61177 then
                texture = "|T" .. 237171 .. " :10:10:0:0|t  "
            else
                texture = "|T" .. GetItemIcon(cditemlink) .. " :10:10:0:0|t  "
            end

        end
    end
    if lccd_isGlobalCooldownIgnored(gname) or lccd_isUserCooldownIgnored(gname)
	then
		return
	end
	if seconds < 0
	then
		local mcooldown1 = format("%s%s%s " .. ("|cff8AE234" ..lccd_readyouttxt .. "|r") .. " %s", prefix, gradient, texture .. skillName, timeStr)
        local mcooldown11 = format("|r%s%s " .. ("|cff8AE234" ..lccd_readyouttxt .. "|r"), gradient, texture .. skillName)
        local mcooldown111 = format("|r%s%s " .. ("|cff8AE234" ..lccd_readyouttxt .. "|r"), gradient, texture .. skillName)
        if istooltip == false
            then            
    		print(mcooldown1)
		end
--		UIErrorsFrame:AddMessage(mcooldown1)
        mmessage = mmessage .. "\n" .. mcooldown11
        mmessagett = mmessagett .. "\n" .. mcooldown111
 	else
	    if ((seconds/3600) < 24) and ((date("%w", (time()+seconds))) == (date("%w"))) then
            lccd_weeksday = "|cff1BFF08" .. HONOR_TODAY .. "|r"
        else
    	    lccd_weeksday = dayOfWeek[((date("%w", (time()+seconds)))+1)]
	    end
	    local mcooldown2 = format("%s%s%s %s %s %s %s", prefix, gradient, texture .. skillName, timeStr, "|r|cffFFF8BF", lccd_weeksday, date("%H:%M", (time()+seconds)))
	    local mcooldown22 = format("%s%s %s %s %s ", ("|r" .. gradient), texture .. skillName, timeStr, "|r|cffFFF8BF", lccd_weeksday, ("|r|cffFFF8BF" .. date("%H:%M", (time()+seconds))))
	    local mcooldown222 = format("%s%s %s %s %s ", ("|r" .. gradient), texture .. skillName, timeStr, "|r|cffFFF8BF", lccd_weeksday, ("|r|cffFFF8BF" .. date("%H:%M", (time()+seconds))))
        if istooltip == false
            then
    		print(mcooldown2)
		end
        mmessage = mmessage .. "\n" .. mcooldown22
        mmessagett = mmessagett .. "\n" .. mcooldown222
	end
end

function lccd_printCached()
    mmessage= prefix .. lccd_lcraftcooldownstxt
    mmessagett= prefix .. lccd_lcraftcooldownstxt
	for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true)))
	do
		local skillName = entry['name']
        if ((entry['realm'] == GetRealmName("player")) and (entry['char'] == UnitName("player"))) then
            skillName = entry['cooldown']
        end
		local seconds = entry['seconds']['timer']
		local lccd_PC_ItemLink = entry['seconds']['scitemid']
		local readyAt = seconds - time()
		lccd_printSkill(skillName, readyAt, lccd_PC_ItemLink, false, entry['name'], false)
	end
	UIErrorsFrame:AddMessage(mmessage);
end

function lccd_printToltip(anchor, point)
    mmessage= prefix .. lccd_lcraftcooldownstxt
    mmessagett= ""
    local ttprefix = prefix .. lccd_lcraftcooldownstxt
	for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true)))
	do
		local skillName = entry['name']
        if ((entry['realm'] == GetRealmName("player")) and (entry['char'] == UnitName("player"))) then
            skillName = entry['cooldown']
        end
		local seconds = entry['seconds']['timer']
		local lccd_PC_ItemLink = entry['seconds']['scitemid']
		local readyAt = seconds - time()
		lccd_printSkill(skillName, readyAt, lccd_PC_ItemLink, false, entry['name'], true)
	end
	GameTooltip:SetOwner(anchor, point);
	GameTooltip:SetText(ttprefix, nil, nil, nil, nil, 1);
	GameTooltip:AddLine(mmessagett, 1, 1, 1)
    GameTooltip:Show()
end

function lccd_getGradient(seconds)
	local grad = {
		[0] = "|cff00ffff", -- READY
		[1 * 60 * 60] = "|cff00CAFF",
		[2 * 60 * 60] = "|cff32cd32",
		[4 * 60 * 60] = "|cff228b22",
		[8 * 60 * 60] = "|cff006400",
		[12 * 60 * 60] = "|cffffd700",
		[24 * 60 * 60] = "|cffff8c00",
		[48 * 60 * 60] = "|cffff0000",
		[99 * 60 * 60] = "|cff8b0000",
	}
	local keys = {}
	for t,c in pairs(grad)
	do
		table.insert(keys, t)
	end
	table.sort(keys)
	for _, t in pairs(keys)
	do
		if seconds < t
		then 
			return grad[t]
		end
	end
	return grad[99 * 60 * 60]
end


function lccd_disp_time(time)
	if time < 0
	then
		time = time * -1
	end
	local days = floor(time/86400)
	local hours = floor(mod(time, 86400)/3600)
	local minutes = floor(mod(time,3600)/60)
	local seconds = floor(mod(time,60))
	if days == 0
	    then
	    if hours == 0
	        then
	        return format("%dm",minutes)
        else
            return format("%dh %dm",hours,minutes)
        end
    else
        if minutes > 30
            then
            hours = hours + 1
        end
    	return format("%dd %dh",days,hours)
	end
end

function lccd_demo()
	local matrixd = {
		{ 0, "READY"}, -- READY
		{ 1 * 60 * 60, "0-1h"},
		{ 2 * 60 * 60, "1-2h"},
		{ 4 * 60 * 60, "2-4h"},
		{ 8 * 60 * 60, "4-8h"},
		{ 12 * 60 * 60, "8-12h"},
		{ 24 * 60 * 60, "12-24h"},
		{ 48 * 60 * 60, "24-48h"},
		{ 99 * 60 * 60, "48h+"}
	}
	for _, row in pairs(matrixd)
	do
		local t, s = row[1], row[2]
        lccd_printSkill(s, t-60, nil, nil, nil, false)
	end
end

function lccd_ignoredcleanup()
    for key, _ in pairs(lccd_globalCache['globalIgnored']) do
        local gcd_found = false
        for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
            if entry['name'] == key then
                gcd_found = true
            end
        end
        if not gcd_found then
            lccd_globalCache['globalIgnored'][key] = nil
        end
    end
    for key, _ in pairs(lccd_usercache['userignored']) do
        local ucd_found = false
        for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
            if entry['name'] == key then
                ucd_found = true
            end
        end
        if not ucd_found then
            lccd_usercache['userignored'][key] = nil
        end
    end
end

function lccd_sortHash1(hash)
	local tbl = {}
	for _, key in pairs(hash)
	do
        local sortrealm = "2" .. key['realm']

        if key['realm'] == GetRealmName("player") then
            sortrealm = "1" .. key['realm']
        end        

        if (key['realm'] == GetRealmName("player")) and (key['char'] == UnitName("player")) then
            sortrealm = "0" .. key['realm']
        end
        
		local entry = {
			['name'] = key['name'],
            ['realm'] = key['realm'],
            ['sortkey'] = sortrealm,
            ['char'] = key['char'],
            ['cooldown'] = key['cooldown'],
            ['profession'] = key['profession'],
			['seconds'] = {
                ['timer'] = key['timer'],
                ['scitemid'] = key['scitemid']
                }
            }
		table.insert(tbl, entry)
	end
    table.sort(tbl, function(a, b)
        if a['sortkey'] ~= b['sortkey'] then
            return a['sortkey'] < b['sortkey']
        end
        return a['char'] < b['char']
        end)
	return tbl
end

function lccd_getfiltertable(filterkey)
    local filtertbl = {}
    for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true))) do
        local filtername = entry[filterkey]
        if filterkey == "profession" then
            filtername, _ = GetSpellInfo(entry[filterkey])
        end
        if filterkey == "seconds" then
            local cditemID = entry[filterkey]['scitemid']
            if cditemID == 28028
                then
                cditemID = 22459
            end
            if cditemID == 28027
                then
                cditemID = 22460
            end
            filtername, _ = GetItemInfo(cditemID)
            filtertbl[filtername] = {
            ["name"] = filtername,
            ["dname"] = entry["cooldown"],
            ["key"] = entry[filterkey]['scitemid'],
            }
        else
            filtertbl[filtername] = {
                ["name"] = filtername,
                ["dname"] = filtername,
                ["key"] = entry[filterkey],
                }
        end
    end
    local filtertblout ={}
    for _, entry in pairs(filtertbl) do
        table.insert(filtertblout, entry)
    end
    table.sort(filtertblout, function(a, b)
        return a['dname'] < b['dname']
        end)
    local filtertbloutsimple= {}
    for _, entry in pairs(filtertblout) do
        table.insert(filtertbloutsimple, entry['dname'])
    end
    return filtertblout, filtertbloutsimple
end

function lccd_printwidget()
    local lccd_widgettable = {}
	for _, entry in pairs(lccd_sortHash1(lccd_getGlobalCooldowns(true)))
	do
        if not ((lccd_isGlobalCooldownIgnored(entry["name"]) or lccd_isUserCooldownIgnored(entry["name"]))) and ((entry["seconds"]["timer"] - time()) < 0)
        then
            if lccd_widgettable[(format("%s-%s", entry["char"], entry["realm"]))] == nil then
                lccd_widgettable[(format("%s-%s", entry["char"], entry["realm"]))] ={
                    ["char"] = entry["char"],
                    ["realm"] = entry["realm"],
                    ["icons"] = {}
                    }
            end

            local cditemlink = entry["seconds"]["scitemid"]
            if cditemlink == 28028
                then
                cditemlink = 22459
            end
            if cditemlink == 28027
                then
                cditemlink = 22460
            end

            local texture = "|T" .. GetItemIcon(cditemlink) .. " :10:10:0:0|t"

            if cditemlink == 61288 or cditemlink == 61177 then
                texture = "|T" .. 237171 .. " :10:10:0:0|t"
            end
            
                table.insert(lccd_widgettable[(format("%s-%s", entry["char"], entry["realm"]))]["icons"], texture)
            --print(entry['name'] .. texture)
        end
    end
    local lccd_widgettablesort = {}
    for _, entry in pairs(lccd_widgettable) do

        local sortrealm = "2" .. entry['realm']

        if entry['realm'] == GetRealmName("player") then
            sortrealm = "1" .. entry['realm']
        end        

        if (entry['realm'] == GetRealmName("player")) and (entry['char'] == UnitName("player")) then
            sortrealm = "0" .. entry['realm']
        end

        local tableentry = {
            ["sort"] = sortrealm,
            ["char"] = entry['char'],
            ["realm"] = entry["realm"],
            ["icons"] = entry["icons"],
            }
        table.insert(lccd_widgettablesort, tableentry)
    end
    table.sort(lccd_widgettablesort, function(a, b)
    if a['sort'] ~= b['sort'] then
        return a['sort'] < b['sort']
    end
    return a['char'] < b['char']
    end)
    local numberofcds = 0
    local stringlengthprev = 0
    local textforwg = nil
    for _, entry in pairs(lccd_widgettablesort) do
        local icons = ""
        local stringlength = 0
        for _, icon in pairs(entry["icons"]) do
            icons = icons .. icon
            stringlength = stringlength + 10
        end
        stringlength = stringlength + (strlen(format("%s-%s ", entry["char"], entry["realm"]))*10)
        numberofcds = numberofcds + 1
        local textout = ((format("|cffABC3DC%s|r-|cffE9B96E%s|r ", entry["char"], entry["realm"])) .. icons)
        --print(textout)
        if textforwg == nil then
            textforwg = textout
        else
            textforwg = textforwg .. "\n" .. textout
        end
        if stringlength > stringlengthprev then
            stringlengthprev = stringlength
        end
    end
    if numberofcds == 0 then
        textforwg = "|cffABC3DC" .. lccd_txt_ncdready .. "|r"
        numberofcds = 1
        stringlengthprev = (strlen(lccd_txt_ncdready) * 10)
    end
    lccd_widgettxt:SetText(textforwg)
    --print(numberofcds .. " - " .. stringlengthprev)
    lccd_widget:SetWidth((stringlengthprev/1.5))
    lccd_widget:SetHeight((numberofcds * 10)+10);
    if lccd_widget:IsVisible() then
        lccd_widgetButton:SetHeight((numberofcds * 10)+10)
    else
        lccd_widgetButton:SetHeight(20)
    end
    return lccd_widgettablesort
end
